package com.engine.salary.elog.config;

import com.engine.salary.mapper.elog.ElogTableCheckerMapper;
import com.engine.salary.elog.util.db.MapperProxyFactory;

import java.util.HashMap;
import java.util.Map;

public class ELogCache {

    private Map<String, Long> tableCache = new HashMap<>();

    private ElogTableCheckerMapper getTableCheckerMapper() {
        return MapperProxyFactory.getProxy(ElogTableCheckerMapper.class);
    }

    public Long getVersion(String mainTable) {
        Long version = tableCache.get(mainTable);
        if (version == null) {
            version = getTableCheckerMapper().getVersion(mainTable);
            tableCache.put(mainTable, version);
        }
        return version;
    }
}
