package com.engine.salary.elog.entity.dto;

import com.engine.salary.elog.annotation.ApiModel;
import com.engine.salary.elog.annotation.ApiModelProperty;

import java.io.Serializable;

/**
 * @ClassName: TableChangeBean
 * @Description 表更新前后值类
 * @Author tanghj
 * @Date 2021/3/8 15:58
 */
@ApiModel("表更新前后值类")
public class TableChangeBean<T> implements Serializable {

    private static final long serialVersionUID = 15869325700230992L;

    @ApiModelProperty("表名")
    private String tableName;

    @ApiModelProperty("数据id")
    private String dataid;

    @ApiModelProperty("所属主表数据id")
    private String belongDataid;

    @ApiModelProperty("是否为明细表（0,否；1，是）")
    private int isDetail = 0;

    /**
     * 泛型必须是具体的实体类
     */
    @ApiModelProperty("更新前的值")
    private T oldValue;

    /**
     * 泛型必须是具体的实体类
     */
    @ApiModelProperty("更新后的值")
    private T newValue;

    /**
     * 泛型必须是具体的实体类
     */
    @ApiModelProperty("更新前显示的值")
    private T oldRealValue;

    /**
     * 泛型必须是具体的实体类
     */
    @ApiModelProperty("更新后显示的值")
    private T newRealValue;


    @ApiModelProperty("字段对应的labelid")
    private String fieldNameLabelId;

    @ApiModelProperty("表对应的labelid")
    private String tableNameLabelId;

    @ApiModelProperty("对应数据库的表")
    private String tableNameDesc;


    public String getTableName() {
        return tableName;
    }

    public void setTableName(String tableName) {
        this.tableName = tableName;
    }

    public T getOldValue() {
        return oldValue;
    }

    public void setOldValue(T oldValue) {
        this.oldValue = oldValue;
    }

    public T getNewValue() {
        return newValue;
    }

    public void setNewValue(T newValue) {
        this.newValue = newValue;
    }

    public String getDataid() {
        return dataid;
    }

    public void setDataid(String dataid) {
        this.dataid = dataid;
    }

    public String getBelongDataid() {
        return belongDataid;
    }

    public void setBelongDataid(String belongDataid) {
        this.belongDataid = belongDataid;
    }

    public int getIsDetail() {
        return isDetail;
    }

    public void setIsDetail(int isDetail) {
        this.isDetail = isDetail;
    }

    public T getOldRealValue() {
        return oldRealValue;
    }

    public void setOldRealValue(T oldRealValue) {
        this.oldRealValue = oldRealValue;
    }

    public T getNewRealValue() {
        return newRealValue;
    }

    public String getFieldNameLabelId() {
        return fieldNameLabelId;
    }

    public void setFieldNameLabelId(String fieldNameLabelId) {
        this.fieldNameLabelId = fieldNameLabelId;
    }

    public String getTableNameLabelId() {
        return tableNameLabelId;
    }

    public void setTableNameLabelId(String tableNameLabelId) {
        this.tableNameLabelId = tableNameLabelId;
    }

    public String getTableNameDesc() {
        return tableNameDesc;
    }

    public void setTableNameDesc(String tableNameDesc) {
        this.tableNameDesc = tableNameDesc;
    }

    public void setNewRealValue(T newRealValue) {
        this.newRealValue = newRealValue;
    }
}
