package com.engine.salary.elog.util;

import cn.hutool.core.map.CaseInsensitiveMap;
import com.alibaba.druid.proxy.jdbc.ClobProxyImpl;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cloudstore.eccom.pc.table.WeaTable;
import com.cloudstore.eccom.pc.table.WeaTableColumn;
import com.engine.salary.elog.annotation.OperateType;
import com.engine.salary.elog.enums.ElogConsts;
import com.engine.salary.elog.util.SalaryI18nUtil;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import weaver.conn.RecordSet;

import java.sql.Clob;
import java.util.*;

/**
 * @Date: 2022/5/18 19:34
 * @Author: deli.xu
 * @Description: elog服务转换类
 **/
public class ElogSeviceSwitchUtils {

    private static final Logger logger = LoggerFactory.getLogger(ElogSeviceSwitchUtils.class);
    // TODO 后续需要考虑多语言label写法
    public static final Map<String, Integer> moduleMap = new HashMap<>();

    private static final Map<String, Map<String, String>> moduleFuctionMap = new HashMap<>();

    static {
        /*moduleMap.put("elog", SalaryI18nUtil.getI18nLabel(62975, ElogSeviceUtils.currentLanguage(), "日志"));
        moduleMap.put("report", SalaryI18nUtil.getI18nLabel(62976, ElogSeviceUtils.currentLanguage(), "报表"));
        moduleMap.put("edc", SalaryI18nUtil.getI18nLabel(62977, ElogSeviceUtils.currentLanguage(), "数据中心"));
        moduleMap.put("hrm", SalaryI18nUtil.getI18nLabel(62978, ElogSeviceUtils.currentLanguage(), "人力资源"));
        moduleMap.put("crm", SalaryI18nUtil.getI18nLabel(62979, ElogSeviceUtils.currentLanguage(), "资产"));
        moduleMap.put("demo", SalaryI18nUtil.getI18nLabel(62980, ElogSeviceUtils.currentLanguage(), "示例"));
        moduleMap.put("attc", SalaryI18nUtil.getI18nLabel(62981, ElogSeviceUtils.currentLanguage(), "出勤打卡"));
        moduleMap.put("attm", SalaryI18nUtil.getI18nLabel(62982, ElogSeviceUtils.currentLanguage(), "出勤机"));
        moduleMap.put("attw", SalaryI18nUtil.getI18nLabel(62983, ElogSeviceUtils.currentLanguage(), "出勤报表"));
        moduleMap.put("auth", SalaryI18nUtil.getI18nLabel(62984, ElogSeviceUtils.currentLanguage(), "系统权限"));
        moduleMap.put("bank", SalaryI18nUtil.getI18nLabel(62985, ElogSeviceUtils.currentLanguage(), "银企直联"));
        moduleMap.put("bap", SalaryI18nUtil.getI18nLabel(62986, ElogSeviceUtils.currentLanguage(), "云办公"));
        moduleMap.put("base", SalaryI18nUtil.getI18nLabel(62987, ElogSeviceUtils.currentLanguage(), "应用管理"));
        moduleMap.put("batc", SalaryI18nUtil.getI18nLabel(62988, ElogSeviceUtils.currentLanguage(), "导入导出"));
        moduleMap.put("blog", SalaryI18nUtil.getI18nLabel(62989, ElogSeviceUtils.currentLanguage(), "日报微博"));
        moduleMap.put("cld", SalaryI18nUtil.getI18nLabel(62990, ElogSeviceUtils.currentLanguage(), "日程管理"));
        moduleMap.put("cmca", SalaryI18nUtil.getI18nLabel(62991, ElogSeviceUtils.currentLanguage(), "资金管理"));
        moduleMap.put("cmcl", SalaryI18nUtil.getI18nLabel(62992, ElogSeviceUtils.currentLanguage(), "线索管理"));
        moduleMap.put("cmco", SalaryI18nUtil.getI18nLabel(62993, ElogSeviceUtils.currentLanguage(), "联系人管理"));
        moduleMap.put("cmcp", SalaryI18nUtil.getI18nLabel(62994, ElogSeviceUtils.currentLanguage(), "对手管理"));
        moduleMap.put("cmcu", SalaryI18nUtil.getI18nLabel(62995, ElogSeviceUtils.currentLanguage(), "客户管理"));
        moduleMap.put("cmex", SalaryI18nUtil.getI18nLabel(62996, ElogSeviceUtils.currentLanguage(), "批量操作"));
        moduleMap.put("cmmk", SalaryI18nUtil.getI18nLabel(62997, ElogSeviceUtils.currentLanguage(), "营销管理"));
        moduleMap.put("cmor", SalaryI18nUtil.getI18nLabel(62998, ElogSeviceUtils.currentLanguage(), "订单管理"));
        moduleMap.put("cmpc", SalaryI18nUtil.getI18nLabel(62999, ElogSeviceUtils.currentLanguage(), "价格管理"));
        moduleMap.put("cmpr", SalaryI18nUtil.getI18nLabel(63000, ElogSeviceUtils.currentLanguage(), "产品管理"));
        moduleMap.put("cmpt", SalaryI18nUtil.getI18nLabel(63001, ElogSeviceUtils.currentLanguage(), "外部门户"));
        moduleMap.put("cmqu", SalaryI18nUtil.getI18nLabel(63002, ElogSeviceUtils.currentLanguage(), "报价管理"));
        moduleMap.put("cmsa", SalaryI18nUtil.getI18nLabel(63003, ElogSeviceUtils.currentLanguage(), "商机管理"));
        moduleMap.put("cmtr", SalaryI18nUtil.getI18nLabel(63004, ElogSeviceUtils.currentLanguage(), "合同管理"));
        moduleMap.put("comp", SalaryI18nUtil.getI18nLabel(63005, ElogSeviceUtils.currentLanguage(), "文档对比"));
        moduleMap.put("cs", SalaryI18nUtil.getI18nLabel(63006, ElogSeviceUtils.currentLanguage(), "云商店"));
        moduleMap.put("cowork", SalaryI18nUtil.getI18nLabel(63007, ElogSeviceUtils.currentLanguage(), "协作区"));
        moduleMap.put("dbs", SalaryI18nUtil.getI18nLabel(63008, ElogSeviceUtils.currentLanguage(), "文档公共模块"));
        moduleMap.put("dcad", SalaryI18nUtil.getI18nLabel(63009, ElogSeviceUtils.currentLanguage(), "数据中心运行"));
        moduleMap.put("dcap", SalaryI18nUtil.getI18nLabel(63010, ElogSeviceUtils.currentLanguage(), "数据中心分析开发配置"));
        moduleMap.put("dcrd", SalaryI18nUtil.getI18nLabel(63011, ElogSeviceUtils.currentLanguage(), "数据中心开发配置"));
        moduleMap.put("dcre", SalaryI18nUtil.getI18nLabel(63012, ElogSeviceUtils.currentLanguage(), "数据中心分析生产运行"));
        moduleMap.put("dcs", SalaryI18nUtil.getI18nLabel(63013, ElogSeviceUtils.currentLanguage(), "文档目录模块"));
        moduleMap.put("dds", SalaryI18nUtil.getI18nLabel(63014, ElogSeviceUtils.currentLanguage(), "文档模块"));
        moduleMap.put("dps", SalaryI18nUtil.getI18nLabel(63015, ElogSeviceUtils.currentLanguage(), "文档权限模块"));
        moduleMap.put("drle", SalaryI18nUtil.getI18nLabel(63016, ElogSeviceUtils.currentLanguage(), "数据规则库"));
        moduleMap.put("ds", SalaryI18nUtil.getI18nLabel(63017, ElogSeviceUtils.currentLanguage(), "数据安全"));
        moduleMap.put("dw_etl", SalaryI18nUtil.getI18nLabel(63018, ElogSeviceUtils.currentLanguage(), "ETL(抽取，转换，治理）"));
        moduleMap.put("dw_model", SalaryI18nUtil.getI18nLabel(63019, ElogSeviceUtils.currentLanguage(), "建模服务"));
        moduleMap.put("dw_process", SalaryI18nUtil.getI18nLabel(63020, ElogSeviceUtils.currentLanguage(), "计算服务"));
        moduleMap.put("dw_search", SalaryI18nUtil.getI18nLabel(63021, ElogSeviceUtils.currentLanguage(), "查询服务"));
        moduleMap.put("dw_sync", SalaryI18nUtil.getI18nLabel(63022, ElogSeviceUtils.currentLanguage(), "数据抽取"));
        moduleMap.put("eb", SalaryI18nUtil.getI18nLabel(63023, ElogSeviceUtils.currentLanguage(), "云桥"));
        moduleMap.put("ebda", SalaryI18nUtil.getI18nLabel(62987, ElogSeviceUtils.currentLanguage(), "应用管理"));
        moduleMap.put("ebdd", SalaryI18nUtil.getI18nLabel(63024, ElogSeviceUtils.currentLanguage(), "页面设计"));
        moduleMap.put("ebdf", SalaryI18nUtil.getI18nLabel(63025, ElogSeviceUtils.currentLanguage(), "表单服务"));
        moduleMap.put("ebdp", SalaryI18nUtil.getI18nLabel(63026, ElogSeviceUtils.currentLanguage(), "页面管理"));
        moduleMap.put("ecod", SalaryI18nUtil.getI18nLabel(63027, ElogSeviceUtils.currentLanguage(), "ecode"));
        moduleMap.put("ei", SalaryI18nUtil.getI18nLabel(63028, ElogSeviceUtils.currentLanguage(), "数据导出导入"));
        moduleMap.put("em", SalaryI18nUtil.getI18nLabel(63029, ElogSeviceUtils.currentLanguage(), "移动相关"));
        moduleMap.put("es", SalaryI18nUtil.getI18nLabel(63030, ElogSeviceUtils.currentLanguage(), "微搜搜索"));
        moduleMap.put("esa", SalaryI18nUtil.getI18nLabel(63031, ElogSeviceUtils.currentLanguage(), "微搜文件分析"));
        moduleMap.put("esb", SalaryI18nUtil.getI18nLabel(63032, ElogSeviceUtils.currentLanguage(), "ESB"));
        moduleMap.put("esch", SalaryI18nUtil.getI18nLabel(63033, ElogSeviceUtils.currentLanguage(), "计划任务"));
        moduleMap.put("esd", SalaryI18nUtil.getI18nLabel(63034, ElogSeviceUtils.currentLanguage(), "微搜索引数据"));
        moduleMap.put("exfo", SalaryI18nUtil.getI18nLabel(63035, ElogSeviceUtils.currentLanguage(), "excel函数引擎"));
        moduleMap.put("fbdg", SalaryI18nUtil.getI18nLabel(63036, ElogSeviceUtils.currentLanguage(), "预算编制"));
        moduleMap.put("fdt", SalaryI18nUtil.getI18nLabel(63037, ElogSeviceUtils.currentLanguage(), "表单数据"));
        moduleMap.put("fexs", SalaryI18nUtil.getI18nLabel(63038, ElogSeviceUtils.currentLanguage(), "费用管理"));
        moduleMap.put("file", SalaryI18nUtil.getI18nLabel(63039, ElogSeviceUtils.currentLanguage(), "文件服务"));
        moduleMap.put("finc", SalaryI18nUtil.getI18nLabel(63040, ElogSeviceUtils.currentLanguage(), "微报账"));
        moduleMap.put("fnar", SalaryI18nUtil.getI18nLabel(63041, ElogSeviceUtils.currentLanguage(), "财务报表"));
        moduleMap.put("fomo", SalaryI18nUtil.getI18nLabel(63042, ElogSeviceUtils.currentLanguage(), "表单监控"));
        moduleMap.put("form", SalaryI18nUtil.getI18nLabel(63043, ElogSeviceUtils.currentLanguage(), "表单服务"));
        moduleMap.put("frpt", SalaryI18nUtil.getI18nLabel(63043, ElogSeviceUtils.currentLanguage(), "业务表单"));
        moduleMap.put("fvou", SalaryI18nUtil.getI18nLabel(63044, ElogSeviceUtils.currentLanguage(), "凭证集成"));
        moduleMap.put("hp", SalaryI18nUtil.getI18nLabel(63045, ElogSeviceUtils.currentLanguage(), "门户"));
        moduleMap.put("hr", SalaryI18nUtil.getI18nLabel(63046, ElogSeviceUtils.currentLanguage(), "人事档案"));
        moduleMap.put("ic", SalaryI18nUtil.getI18nLabel(63047, ElogSeviceUtils.currentLanguage(), "集成服务"));
        moduleMap.put("il", SalaryI18nUtil.getI18nLabel(63048, ElogSeviceUtils.currentLanguage(), "集成登录"));
        moduleMap.put("im", SalaryI18nUtil.getI18nLabel(63049, ElogSeviceUtils.currentLanguage(), "IM相关服务"));
        moduleMap.put("inc", SalaryI18nUtil.getI18nLabel(63050, ElogSeviceUtils.currentLanguage(), "发票云服务"));
        moduleMap.put("iua", SalaryI18nUtil.getI18nLabel(63051, ElogSeviceUtils.currentLanguage(), "统一认证"));
        moduleMap.put("iut", SalaryI18nUtil.getI18nLabel(63052, ElogSeviceUtils.currentLanguage(), "统一待办"));
        moduleMap.put("mail", SalaryI18nUtil.getI18nLabel(63053, ElogSeviceUtils.currentLanguage(), "邮件服务"));
        moduleMap.put("mc", SalaryI18nUtil.getI18nLabel(63054, ElogSeviceUtils.currentLanguage(), "消息服务"));
        moduleMap.put("mt", SalaryI18nUtil.getI18nLabel(63055, ElogSeviceUtils.currentLanguage(), "会议管理"));
        moduleMap.put("my", SalaryI18nUtil.getI18nLabel(63056, ElogSeviceUtils.currentLanguage(), "关注&收藏&标签"));
        moduleMap.put("odoc", SalaryI18nUtil.getI18nLabel(63057, ElogSeviceUtils.currentLanguage(), "公文管理"));
        moduleMap.put("odoc_exchange", SalaryI18nUtil.getI18nLabel(63058, ElogSeviceUtils.currentLanguage(), "公文交换平台"));
        moduleMap.put("open", SalaryI18nUtil.getI18nLabel(63059, ElogSeviceUtils.currentLanguage(), "开放平台"));
        moduleMap.put("pr", SalaryI18nUtil.getI18nLabel(63060, ElogSeviceUtils.currentLanguage(), "工作画像"));
        moduleMap.put("proj", SalaryI18nUtil.getI18nLabel(63061, ElogSeviceUtils.currentLanguage(), "项目管理"));
        moduleMap.put("prt", SalaryI18nUtil.getI18nLabel(63062, ElogSeviceUtils.currentLanguage(), "打印服务"));
        moduleMap.put("pspt", SalaryI18nUtil.getI18nLabel(63063, ElogSeviceUtils.currentLanguage(), "系统登录"));
        moduleMap.put("rptc", SalaryI18nUtil.getI18nLabel(63064, ElogSeviceUtils.currentLanguage(), "数据协作"));
        moduleMap.put("rpts", SalaryI18nUtil.getI18nLabel(63065, ElogSeviceUtils.currentLanguage(), "上报调查"));
        moduleMap.put("sala", SalaryI18nUtil.getI18nLabel(63066, ElogSeviceUtils.currentLanguage(), "薪资管理"));
        moduleMap.put("sign", SalaryI18nUtil.getI18nLabel(63067, ElogSeviceUtils.currentLanguage(), "印控中心"));
        moduleMap.put("sms", SalaryI18nUtil.getI18nLabel(63068, ElogSeviceUtils.currentLanguage(), "短信"));
        moduleMap.put("task", SalaryI18nUtil.getI18nLabel(63069, ElogSeviceUtils.currentLanguage(), "任务管理"));
        moduleMap.put("tnt", SalaryI18nUtil.getI18nLabel(63070, ElogSeviceUtils.currentLanguage(), "租户管理"));
        moduleMap.put("wf", SalaryI18nUtil.getI18nLabel(63071, ElogSeviceUtils.currentLanguage(), "路径定义"));
        moduleMap.put("wfc", SalaryI18nUtil.getI18nLabel(63072, ElogSeviceUtils.currentLanguage(), "流程流转"));
        moduleMap.put("wfr", SalaryI18nUtil.getI18nLabel(63073, ElogSeviceUtils.currentLanguage(), "流程规则路由"));
        moduleMap.put("wrgm", SalaryI18nUtil.getI18nLabel(63074, ElogSeviceUtils.currentLanguage(), "目标管理"));
        moduleMap.put("wrgp", SalaryI18nUtil.getI18nLabel(63075, ElogSeviceUtils.currentLanguage(), "绩效考核"));
        moduleMap.put("wrpr", SalaryI18nUtil.getI18nLabel(63076, ElogSeviceUtils.currentLanguage(), "计划报告"));
        moduleMap.put("doc", SalaryI18nUtil.getI18nLabel(63077, ElogSeviceUtils.currentLanguage(), "文档服务"));
        moduleMap.put("placard", SalaryI18nUtil.getI18nLabel(63078, ElogSeviceUtils.currentLanguage(), "团队公告"));
        moduleMap.put("fna", SalaryI18nUtil.getI18nLabel(135042, ElogSeviceUtils.currentLanguage(), "云报销"));
        moduleMap.put("meeting", SalaryI18nUtil.getI18nLabel(63080, ElogSeviceUtils.currentLanguage(), "会议"));
        moduleMap.put("wfp", SalaryI18nUtil.getI18nLabel(63081, ElogSeviceUtils.currentLanguage(), "流程"));
        moduleMap.put("portal", SalaryI18nUtil.getI18nLabel(63045, ElogSeviceUtils.currentLanguage(), "门户"));
        moduleMap.put("workreport", SalaryI18nUtil.getI18nLabel(63082, ElogSeviceUtils.currentLanguage(), "工作报告"));
        moduleMap.put("goal", SalaryI18nUtil.getI18nLabel(63074, ElogSeviceUtils.currentLanguage(), "目标管理"));
        moduleMap.put("performance", SalaryI18nUtil.getI18nLabel(63075, ElogSeviceUtils.currentLanguage(), "绩效考核"));
        moduleMap.put("intlogin", SalaryI18nUtil.getI18nLabel(63083, ElogSeviceUtils.currentLanguage(), "集成登录设置"));
        moduleMap.put("i18n", SalaryI18nUtil.getI18nLabel(64559, ElogSeviceUtils.currentLanguage(), "国际化"));
        moduleMap.put("timecard", SalaryI18nUtil.getI18nLabel(63085, ElogSeviceUtils.currentLanguage(), "出勤"));
        moduleMap.put("market", SalaryI18nUtil.getI18nLabel(63086, ElogSeviceUtils.currentLanguage(), "营销"));
        moduleMap.put("excelformula", SalaryI18nUtil.getI18nLabel(64560, ElogSeviceUtils.currentLanguage(), "函数服务"));
        moduleMap.put("ic_ldap", SalaryI18nUtil.getI18nLabel(70081, ElogSeviceUtils.currentLanguage(), "Ldap集成"));
        moduleMap.put("iut_c_c", SalaryI18nUtil.getI18nLabel(70303, ElogSeviceUtils.currentLanguage(), "统一待办推送设置"));
        moduleMap.put("plan", SalaryI18nUtil.getI18nLabel(70303, ElogSeviceUtils.currentLanguage(), "计划报告"));
        moduleMap.put("document", SalaryI18nUtil.getI18nLabel(34218, ElogSeviceUtils.currentLanguage(), "文档"));
        moduleMap.put("taskCustStatus", SalaryI18nUtil.getI18nLabel(73988, ElogSeviceUtils.currentLanguage(), "任务状态"));
        moduleMap.put("project", SalaryI18nUtil.getI18nLabel(55158, ElogSeviceUtils.currentLanguage(), "项目"));
        moduleMap.put("calendar", SalaryI18nUtil.getI18nLabel(74186, ElogSeviceUtils.currentLanguage(), "日历"));
        moduleMap.put("web", SalaryI18nUtil.getI18nLabel(75598, ElogSeviceUtils.currentLanguage(), "浏览"));
        moduleMap.put("formdatareport", SalaryI18nUtil.getI18nLabel(76068, ElogSeviceUtils.currentLanguage(), "来自上报数据"));
        moduleMap.put("mainline", SalaryI18nUtil.getI18nLabel(31898, ElogSeviceUtils.currentLanguage(), "主线"));
        moduleMap.put("customer", SalaryI18nUtil.getI18nLabel(32726, ElogSeviceUtils.currentLanguage(), "客户"));
        moduleMap.put("contract", SalaryI18nUtil.getI18nLabel(32864, ElogSeviceUtils.currentLanguage(), "合同"));
        moduleMap.put("group", SalaryI18nUtil.getI18nLabel(19426, ElogSeviceUtils.currentLanguage(), "分组"));
        moduleMap.put("workflow", SalaryI18nUtil.getI18nLabel(81851, ElogSeviceUtils.currentLanguage(), "工作流程"));
        moduleMap.put("biaoge", SalaryI18nUtil.getI18nLabel(30919, ElogSeviceUtils.currentLanguage(), "表格"));
        moduleMap.put("clue", SalaryI18nUtil.getI18nLabel(28908, ElogSeviceUtils.currentLanguage(), "线索"));
        moduleMap.put("competitor", SalaryI18nUtil.getI18nLabel(81852, ElogSeviceUtils.currentLanguage(), "竞争对手"));
        moduleMap.put("kpiFlow", SalaryI18nUtil.getI18nLabel(81853, ElogSeviceUtils.currentLanguage(), "kpil流程"));
        moduleMap.put("mainlineCustStatus", SalaryI18nUtil.getI18nLabel(81854, ElogSeviceUtils.currentLanguage(), "主线客户状态"));
        moduleMap.put("marketactivity", SalaryI18nUtil.getI18nLabel(34221, ElogSeviceUtils.currentLanguage(), "市场活动"));
        moduleMap.put("mtPhase", SalaryI18nUtil.getI18nLabel(81855, ElogSeviceUtils.currentLanguage(), "mt阶段"));
        moduleMap.put("production", SalaryI18nUtil.getI18nLabel(29329, ElogSeviceUtils.currentLanguage(), "产品"));
        moduleMap.put("quote", SalaryI18nUtil.getI18nLabel(34231, ElogSeviceUtils.currentLanguage(), "报价"));
        moduleMap.put("saleChance", SalaryI18nUtil.getI18nLabel(32863, ElogSeviceUtils.currentLanguage(), "商机"));
        moduleMap.put("orderform", SalaryI18nUtil.getI18nLabel(34230, ElogSeviceUtils.currentLanguage(), "订单"));
        moduleMap.put("contact", SalaryI18nUtil.getI18nLabel(32711, ElogSeviceUtils.currentLanguage(), "联系人"));
        moduleMap.put("price", SalaryI18nUtil.getI18nLabel(31922, ElogSeviceUtils.currentLanguage(), "价格"));
        moduleMap.put("capital", SalaryI18nUtil.getI18nLabel(83428, ElogSeviceUtils.currentLanguage(), "资金"));
        moduleMap.put("ice", SalaryI18nUtil.getI18nLabel(94360, ElogSeviceUtils.currentLanguage(), "日程会议集成"));
        moduleMap.put("ic_hr", SalaryI18nUtil.getI18nLabel(84284, ElogSeviceUtils.currentLanguage(), "HR同步"));
        moduleMap.put("intunifyauth", SalaryI18nUtil.getI18nLabel(84467, ElogSeviceUtils.currentLanguage(), "统一认证接入管理"));
        moduleMap.put("signcenter", SalaryI18nUtil.getI18nLabel(84691, ElogSeviceUtils.currentLanguage(), "电子签"));
        moduleMap.put("iut_s_c", SalaryI18nUtil.getI18nLabel(91503, ElogSeviceUtils.currentLanguage(), "统一待办-异构系统"));
        moduleMap.put("iut_s_c1", SalaryI18nUtil.getI18nLabel(91503, ElogSeviceUtils.currentLanguage(), "统一待办-应用系统"));
        moduleMap.put("iut_s_c2", SalaryI18nUtil.getI18nLabel(91503, ElogSeviceUtils.currentLanguage(), "统一待办中心"));
        moduleMap.put("iut_s_c3", SalaryI18nUtil.getI18nLabel(91503, ElogSeviceUtils.currentLanguage(), "统一待办-应用系统-流程类型"));
        moduleMap.put("ic_mail", SalaryI18nUtil.getI18nLabel(100715, ElogSeviceUtils.currentLanguage(), "邮箱集成"));
        moduleMap.put("hrsa", SalaryI18nUtil.getI18nLabel(105038, ElogSeviceUtils.currentLanguage(), "薪酬管理"));
        moduleMap.put("icc", SalaryI18nUtil.getI18nLabel(113884, ElogSeviceUtils.currentLanguage(), "转换规则"));
        moduleMap.put("basicserver", SalaryI18nUtil.getI18nLabel(113885, ElogSeviceUtils.currentLanguage(), "整体基础"));
        moduleMap.put("dw", SalaryI18nUtil.getI18nLabel(115549, ElogSeviceUtils.currentLanguage(), "数据仓库"));
        moduleMap.put("msg", SalaryI18nUtil.getI18nLabel(115563, ElogSeviceUtils.currentLanguage(), "工作消息"));
        moduleMap.put("intunifybase", SalaryI18nUtil.getI18nLabel(115599, ElogSeviceUtils.currentLanguage(), "统一认证服务"));
        moduleMap.put("esearch", SalaryI18nUtil.getI18nLabel(21694, ElogSeviceUtils.currentLanguage(), "全文检索"));
        moduleMap.put("iaauthserver", SalaryI18nUtil.getI18nLabel(115603, ElogSeviceUtils.currentLanguage(), "统一认证注册应用"));
        moduleMap.put("excel", SalaryI18nUtil.getI18nLabel(115543, ElogSeviceUtils.currentLanguage(), "excel函数"));
        moduleMap.put("scene", SalaryI18nUtil.getI18nLabel(115539, ElogSeviceUtils.currentLanguage(), "绘图"));
        moduleMap.put("bcw", SalaryI18nUtil.getI18nLabel(115651, ElogSeviceUtils.currentLanguage(), "公共模块"));
        moduleMap.put("folder", SalaryI18nUtil.getI18nLabel(10734, ElogSeviceUtils.currentLanguage(), "文件夹"));
        moduleMap.put("pdfcnv", SalaryI18nUtil.getI18nLabel(115957, ElogSeviceUtils.currentLanguage(), "PDF转换服务"));
        moduleMap.put("ebform", SalaryI18nUtil.getI18nLabel(121462, ElogSeviceUtils.currentLanguage(), "e-Builder表单"));
        moduleMap.put("statistics", SalaryI18nUtil.getI18nLabel(17745, ElogSeviceUtils.currentLanguage(), "自定义统计"));
        moduleMap.put("edcapp", SalaryI18nUtil.getI18nLabel(121631, ElogSeviceUtils.currentLanguage(), "多级填报"));

        */

        moduleMap.put("elog", 62975);
        moduleMap.put("report", 62976);
        moduleMap.put("edc", 52689);
        moduleMap.put("hrm", 62978);
        moduleMap.put("crm", 62979);
        moduleMap.put("demo", 62980);
        moduleMap.put("attc", 62981);
        moduleMap.put("attm", 62982);
        moduleMap.put("attw", 62983);
        moduleMap.put("auth", 62984);
        moduleMap.put("bank", 62985);
        moduleMap.put("bap", 62986);
        moduleMap.put("base", 62987);
        moduleMap.put("batc", 62988);
        moduleMap.put("blog", 62989);
        moduleMap.put("cld", 62990);
        moduleMap.put("cmca", 62991);
        moduleMap.put("cmcl", 62992);
        moduleMap.put("cmco", 62993);
        moduleMap.put("cmcp", 62994);
        moduleMap.put("cmcu", 62995);
        moduleMap.put("cmex", 62996);
        moduleMap.put("cmmk", 62997);
        moduleMap.put("cmor", 62998);
        moduleMap.put("cmpc", 62999);
        moduleMap.put("cmpr", 63000);
        moduleMap.put("cmpt", 63001);
        moduleMap.put("cmqu", 63002);
        moduleMap.put("cmsa", 63003);
        moduleMap.put("cmtr", 63004);
        moduleMap.put("comp", 63005);
        moduleMap.put("cs", 63006);
        moduleMap.put("cowork", 63007);
        moduleMap.put("dbs", 63008);
        moduleMap.put("dcad", 63009);
        moduleMap.put("dcap", 63010);
        moduleMap.put("dcrd", 63011);
        moduleMap.put("dcre", 63012);
        moduleMap.put("dcs", 63013);
        moduleMap.put("dds", 63014);
        moduleMap.put("dps", 63015);
        moduleMap.put("drle", 63016);
        moduleMap.put("ds", 63017);
        moduleMap.put("dw_etl", 63018);
        moduleMap.put("dw_model", 63019);
        moduleMap.put("dw_process", 63020);
        moduleMap.put("dw_search", 63021);
        moduleMap.put("dw_sync", 63022);
        moduleMap.put("eb", 63023);
        moduleMap.put("ebda", 62987);
        moduleMap.put("ebdd", 63024);
        moduleMap.put("ebdf", 63025);
        moduleMap.put("ebdp", 63026);
        moduleMap.put("ecod", 63027);
        moduleMap.put("ei", 63028);
        moduleMap.put("em", 63029);
        moduleMap.put("es", 63030);
        moduleMap.put("esa", 63031);
        moduleMap.put("esb", 63032);
        moduleMap.put("esch", 63033);
        moduleMap.put("esd", 63034);
        moduleMap.put("exfo", 63035);
        moduleMap.put("fbdg", 63036);
        moduleMap.put("fdt", 63037);
        moduleMap.put("fexs", 63038);
        moduleMap.put("file", 63039);
        moduleMap.put("finc", 63040);
        moduleMap.put("fnar", 63041);
        moduleMap.put("fomo", 63042);
        moduleMap.put("form", 63043);
        moduleMap.put("frpt", 63043);
        moduleMap.put("fvou", 63044);
        moduleMap.put("hp", 63045);
        moduleMap.put("hr", 63046);
        moduleMap.put("ic", 63047);
        moduleMap.put("il", 63048);
        moduleMap.put("im", 63049);
        moduleMap.put("inc", 63050);
        moduleMap.put("iua", 63051);
        moduleMap.put("iut", 63052);
        moduleMap.put("mail", 63053);
        moduleMap.put("mc", 63054);
        moduleMap.put("mt", 63055);
        moduleMap.put("my", 63056);
        moduleMap.put("odoc", 63057);
        moduleMap.put("odoc_exchange", 63058);
        moduleMap.put("open", 63059);
        moduleMap.put("pr", 63060);
        moduleMap.put("proj", 63061);
        moduleMap.put("prt", 63062);
        moduleMap.put("pspt", 63063);
        moduleMap.put("rptc", 63064);
        moduleMap.put("rpts", 63065);
        moduleMap.put("sala", 63066);
        moduleMap.put("sign", 63067);
        moduleMap.put("sms", 63068);
        moduleMap.put("task", 63069);
        moduleMap.put("tnt", 63070);
        moduleMap.put("wf", 63071);
        moduleMap.put("wfc", 63072);
        moduleMap.put("wfr", 63073);
        moduleMap.put("wrgm", 63074);
        moduleMap.put("wrgp", 63075);
        moduleMap.put("wrpr", 63076);
        moduleMap.put("doc", 63077);
        moduleMap.put("placard", 63078);
        moduleMap.put("fna", 135042);
        moduleMap.put("meeting", 63080);
        moduleMap.put("wfp", 63081);
        moduleMap.put("portal", 63045);
        moduleMap.put("workreport", 63082);
        moduleMap.put("goal", 63074);
        moduleMap.put("performance", 63075);
        moduleMap.put("intlogin", 63083);
        moduleMap.put("i18n", 64559);
        moduleMap.put("timecard", 63085);
        moduleMap.put("market", 63086);
        moduleMap.put("excelformula", 64560);
        moduleMap.put("ebatch", 69280);
        moduleMap.put("ic_ldap", 70081);
        moduleMap.put("iut_c_c", 96493);
        moduleMap.put("plan", 63076);
        moduleMap.put("document", 34218);
        moduleMap.put("taskCustStatus", 73988);
        moduleMap.put("calendar", 74186);
        moduleMap.put("batch", 69280);
        moduleMap.put("project", 55158);
        moduleMap.put("web", 75598);
        moduleMap.put("formdatareport", 76068);
        moduleMap.put("mainline", 31898);
        moduleMap.put("customer", 32726);
        moduleMap.put("contract", 32864);
        moduleMap.put("group", 19426);
        moduleMap.put("workflow", 81851);
        moduleMap.put("biaoge", 30919);
        moduleMap.put("clue", 28908);
        moduleMap.put("competitor", 81852);
        moduleMap.put("kpiFlow", 81853);
        moduleMap.put("mainlineCustStatus", 81854);
        moduleMap.put("marketactivity", 34221);
        moduleMap.put("mtPhase", 81855);
        moduleMap.put("production", 29329);
        moduleMap.put("quote", 34231);
        moduleMap.put("saleChance", 32863);
        moduleMap.put("orderform", 34230);
        moduleMap.put("contact", 32711);
        moduleMap.put("price", 31922);
        moduleMap.put("capital", 83428);
        moduleMap.put("ice", 87722);
        moduleMap.put("ic_hr", 84284);
        moduleMap.put("intunifyauth", 84508);
        moduleMap.put("signcenter", 84691);
        moduleMap.put("iut_s_c", 91503);
        moduleMap.put("iut_s_c1", 95218);
        moduleMap.put("iut_s_c2", 95219);
        moduleMap.put("iut_s_c3", 95220);
        moduleMap.put("iut_c_log", 96494);
        moduleMap.put("ic_mail", 100715);
        moduleMap.put("hrsa", 105038);
        moduleMap.put("icc", 113884);
        moduleMap.put("basicserver", 113885);
        moduleMap.put("dw", 115549);
        moduleMap.put("msg", 115563);
        moduleMap.put("intunifybase", 115599);
        moduleMap.put("esearch", 21694);
        moduleMap.put("iaauthserver", 115603);
        moduleMap.put("excel", 115543);
        moduleMap.put("scene", 115539);
        moduleMap.put("bcw", 115651);
        moduleMap.put("folder", 10734);
        moduleMap.put("pdfcnv", 115957);
        moduleMap.put("login", 63063);
        moduleMap.put("ebform", 121462);
        moduleMap.put("statistics", 17745);
        moduleMap.put("edcapp", 121631);
        moduleMap.put("cusapp", 16381);
        moduleMap.put("e10-allinone-base", 141083);
        moduleMap.put("voice", 142713);
        moduleMap.put("filter", 147832);
        moduleMap.put("ias", 146674);
        moduleMap.put("device", 153666);
        moduleMap.put("meetingTopic", 180274);
        moduleMap.put("meetingService", 180276);
        moduleMap.put("meetingDecision", 180277);
        moduleMap.put("meetingSign", 180278);
        moduleMap.put("meetingSignSet", 61601);
        moduleMap.put("meetingMember", 180280);
        moduleMap.put("meetingShare", 180281);
        moduleMap.put("int", 40031);
        moduleMap.put("print", 160051);
        moduleMap.put("wcwIconUpdate", 182661);
        moduleMap.put("wcwIconRelease", 183123);
        moduleMap.put("wcwIconUse", 183124);
        moduleMap.put("wcw", 29385);
        moduleMap.put("component", 115651);
        moduleMap.put("ic_exchange", 87722);
        moduleMap.put("iut_c_c", 240048);
        moduleMap.put("iut_c_set", 240049);

        Map<String, String> elogMap = new HashMap<>();
        Map<String, String> reportMap = new HashMap<>();
        Map<String, String> edcMap = new HashMap<>();
        Map<String, String> hrmMap = new HashMap<>();
        Map<String, String> crmMap = new HashMap<>();
        Map<String, String> demoMap = new HashMap<>();

        moduleFuctionMap.put("elog", elogMap);
        moduleFuctionMap.put("report", reportMap);
        moduleFuctionMap.put("edc", edcMap);
        moduleFuctionMap.put("hrm", hrmMap);
        moduleFuctionMap.put("crm", crmMap);
        moduleFuctionMap.put("demo", demoMap);


        elogMap.put("operator", "日志操作");
        elogMap.put("reportcusinfo", "报表自定义");
        edcMap.put("dataset", "数据集合");

        demoMap.put("reportcusinfo", "报表自定义字段");
    }

    /**
     * 获取模块名称
     *
     * @param module
     * @return
     */
    public static String getModuleName(String module) {
//        String modulename = ElogSeviceUtils.null2String(moduleMap.get(module), module);
//        return ElogSeviceUtils.isLongValue(modulename) ? SalaryI18nUtil.getI18nLabel(ElogSeviceUtils.getLongValue(modulename), modulename) : modulename;
        return module;
    }

    /**
     * 获取模块名称
     *
     * @param module
     * @return
     */
    public static String getModuleNamePapi(String module) {
//        String modulename = ElogSeviceUtils.null2String(moduleMap.get(module), module);
//        return ElogSeviceUtils.isLongValue(modulename) ? SalaryI18nUtil.getI18nLabel(ElogSeviceUtils.getLongValue(modulename), modulename) : modulename;
        return module;
    }


    /**
     * 获取方法名称
     *
     * @param module
     * @param function
     * @return
     */
    public static String getFunctionName(String module, String function) {
//        Map<String, String> functionMap = moduleFuctionMap.get(module);
//
//        if (functionMap != null)
//            function = ElogSeviceUtils.null2String(functionMap.get(function), function);
//
//        return ElogSeviceUtils.isLongValue(function) ? SalaryI18nUtil.getI18nLabel(ElogSeviceUtils.getLongValue(function), function) : function;
        return function;
    }

    public static void switchValues(List<Map> resultMap, List<String> recordColumns) {

        switchValues(resultMap, recordColumns, false);

    }


    public static void switchValues(List<Map> list, List<String> recordColumns, boolean islocal) {
//        if(!islocal) {
//            changKey2Lower(list);
//        }
        for (Map<String, String> map : list) {
            Iterator<Map.Entry<String, String>> iterator = map.entrySet().iterator();
            while (iterator.hasNext()) {
                Map.Entry<String, String> next = iterator.next();
                for (String recordColumn : recordColumns) {
                    if (next.getKey().equals(recordColumn) && next.getValue() instanceof String) {
                        map.put(next.getKey(), transfi18Method(next.getValue()));
                    }
                }
            }
            map.put("modulenamespan", getModuleName(map.get("modulename")));
            //map.put("functionnamespan", getFunctionName(map.get("modulename"), map.get("functionname")));
            //switchDatabaseField(map);
        }

    }

    public static void switchDatabaseField(Map map) {
        map.put("date", map.get("log_date"));
        map.put("operator", map.get("log_operator"));
        map.put("result", map.get("log_result"));
    }

    /**
     * 转换数据成多语言
     *
     * @param lists
     */
    public static List transfLanguageData(List<Map> lists) {
        if (lists != null && lists.size() > 0) {
            for (Map map : lists) {
                if (map != null) {
                    Iterator<Map.Entry<String, Object>> iterator = map.entrySet().iterator();
                    while (iterator.hasNext()) {
                        Map.Entry<String, Object> entry = iterator.next();
                        if (entry.getValue() instanceof Integer || entry.getValue() instanceof Long || entry.getValue() instanceof String) {
                            map.put(entry.getKey(), transfLanguageLableid(ElogSeviceUtils.getLongValue(entry.getValue().toString()), entry.getValue().toString()));
                        } else {
                            map.put(entry.getKey(), entry.getValue());
                        }
                    }
                }
            }
        }
        return lists;
    }

    public static String transfi18Method(String str) {
        if ("新增".equals(str)) {
            return transfLanguageLableid(63252l, str);
        } else if ("查看".equals(str)) {
            return transfLanguageLableid(55172l, str);
        } else if ("修改".equals(str)) {
            return transfLanguageLableid(63253l, str);
        } else if ("更新".equals(str)) {
            return transfLanguageLableid(29540l, str);
        } else if ("删除".equals(str)) {
            return transfLanguageLableid(63254l, str);
        } else if (StringUtils.isNumeric(str) && str.length() < 10) {
            return transfLanguageLableid(Long.parseLong(str), str);
        } else {
            return str;
        }
    }

    public static String transfLanguageLableid(Long lableid) {
        return SalaryI18nUtil.getI18nLabel(Integer.parseInt(lableid.toString()), lableid.toString());
    }

    /**
     * 转换多语言
     *
     * @param lableid
     * @param def
     * @return
     */
    public static String transfLanguageLableid(Long lableid, String def) {
        return SalaryI18nUtil.getI18nLabel(Integer.parseInt(lableid.toString()), def);
    }


    /**
     * 日志本地服务-更新明细转换
     *
     * @param mainlist
     * @param list
     * @return
     */
    public static Map<String, Object> switchChangeValue(List<Map> mainlist, List<Map> list) {
        Map<String, Object> res = new HashMap<>();
        StringBuilder valuesChange = new StringBuilder();
        List valuesChanges = new ArrayList<>();
        String values = "";
        String operatetypeName = "";
        int oldCount = 0;
        int newCount = 0;
        String operatetype = "";
        CaseInsensitiveMap map = null;
        if (list != null && list.size() > 0) {
            for (Map hashmap : list) {
                map = new CaseInsensitiveMap<>(hashmap);
                Object obj = map.get("operatetype");
                if (obj != null) {
                    operatetype = obj.toString();
                }
            }
        }
        if (mainlist != null && mainlist.size() > 0) {
            for (Map hashMap : mainlist) {
                map = new CaseInsensitiveMap<>(hashMap);
                Object isdetail = map.get("isdetail");
                if (isdetail != null) {
                    if (StringUtils.isBlank(isdetail.toString()) || !"0".equals(isdetail.toString())) {
                        continue;
                    }
                } else {
                    continue;
                }
                Object oldvalue = map.get("oldvalue");
                if (oldvalue != null) {
                    if (StringUtils.isNotBlank(oldvalue.toString())) {
                        oldCount++;
                    }
                }

                Object newvalue = map.get("newvalue");
                if (newvalue != null) {
                    if (StringUtils.isNotBlank(newvalue.toString())) {
                        newCount++;
                    }
                }

            }
        }
        CaseInsensitiveMap<String, String> jo = null;
        for (int i = 0; i < mainlist.size(); i++) {
            Map<String, String> jomap = mainlist.get(i);
            jo = new CaseInsensitiveMap<>(jomap);
            String fieldName = jo.get("fielddesc");
            String oldvalue = obj2String(jo.get("oldvalue"));
            String oldrealvalue = obj2String(jo.get("oldrealvalue"));
            String newValue = obj2String(jo.get("newvalue"));
            String newrealvalue = obj2String(jo.get("newrealvalue"));
            // oracle.sql.CLOB类型处理
            jomap.put("oldvalue", oldvalue);
            jomap.put("oldrealvalue", oldrealvalue);
            jomap.put("newvalue", newValue);
            jomap.put("newrealvalue", newrealvalue);

            String fieldNameLabelId = jo.get("fieldnamelabelid");
            if (StringUtils.isNotBlank(fieldNameLabelId) && StringUtils.isNumeric(fieldNameLabelId)) {
                fieldName = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(fieldNameLabelId), fieldName);
            } else if (StringUtils.isNotBlank(fieldNameLabelId) && !StringUtils.isNumeric(fieldNameLabelId) && !"-1".equals(fieldNameLabelId)) {
                fieldName = fieldNameLabelId;
            } else if (StringUtils.isNotBlank(fieldName) && StringUtils.isNumeric(fieldName)) {
                fieldName = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(fieldName), fieldName);
            }
            if (StringUtils.isNotBlank(oldrealvalue) && StringUtils.isNumeric(oldrealvalue)) {
                oldvalue = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(oldrealvalue), oldvalue);
            } else if (StringUtils.isNotBlank(oldrealvalue) && !StringUtils.isNumeric(oldrealvalue)) {
                oldvalue = oldrealvalue;
            }
            if (StringUtils.isNotBlank(newrealvalue) && StringUtils.isNumeric(newrealvalue)) {
                newValue = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(newrealvalue), newValue);
            } else if (StringUtils.isNotBlank(newrealvalue) && !StringUtils.isNumeric(newrealvalue)) {
                newValue = newrealvalue;
            }

            //oldvalue,newValue 避免xss漏洞 分别进行转义
//            oldvalue = StringConversionForXSS(oldvalue);
//            newValue = StringConversionForXSS(newValue);

            if (oldCount != 0) {
                valuesChanges.add(String.format(valueChangeFormat(), fieldName, oldvalue, newValue));

            } else if (oldCount == 0 || newCount == 0 || operatetype.startsWith(OperateType.add) || operatetype.startsWith(OperateType.delete)) {
                valuesChanges.add(String.format(valueChangeNewFormat(), fieldName, newValue));

            } else {
                valuesChanges.add(String.format(valueChangeFormat(), fieldName, oldvalue, newValue));
            }
            //}
            /*if (valuesChange.length() > 3) {
                values = valuesChange.substring(0, valuesChange.length() - 3);
            }*/
        }

        res.put("valueschanges", valuesChanges);
        res.put("detailcontexts", mainlist);
        return res;
    }

    private static String obj2String(Object o) {
        if (o == null) {
            return "";
        }
        if (o instanceof String) {
            return (String) o;
        }
        return JSON.toJSONString(o);
    }

    /**
     * 服务中心结果集转换
     */
    public static void switchChangeValues(List<Map> list) {
        CaseInsensitiveMap map = null;
        for (Map<String, Object> hashMap : list) {
            map = new CaseInsensitiveMap<>(hashMap);
            int count = 0;
            StringBuilder valuesChange = new StringBuilder();
            List valuesChanges = new ArrayList();
            Object detailContexts = map.get("detailcontexts");
            if (detailContexts != null) {
                JSONArray jsonArray = JSONArray.parseArray(JSON.toJSONString(detailContexts));
                for (int i = 0; i < jsonArray.size(); i++) {
                    JSONObject jo = jsonArray.getJSONObject(i);
                    String isDetail = jo.getString("isDetail");
                    if (StringUtils.isBlank(isDetail) || !"0".equals(isDetail)) {
                        continue;
                    }
                    String oldvalue = jo.getString("oldValue");
                    if (StringUtils.isNotBlank(oldvalue)) {
                        count++;
                    }
                }
            }

            if (detailContexts != null) {
                JSONArray jsonArray = JSONArray.parseArray(JSON.toJSONString(detailContexts));
                for (int i = 0; i < jsonArray.size(); i++) {
                    JSONObject jo = jsonArray.getJSONObject(i);
                    String isDetail = jo.getString("isDetail");
                    if (StringUtils.isBlank(isDetail) || !"0".equals(isDetail)) {
                        continue;
                    }
                    String fieldName = jo.getString("fieldDesc");
                    String oldvalue = jo.getString("oldValue");
                    String oldrealvalue = jo.getString("oldRealValue");
                    String newValue = jo.getString("newValue");
                    String newrealvalue = jo.getString("newRealValue");
                    String fieldNameLabelId = jo.getString("fieldNameLabelId");
                    if (StringUtils.isNotBlank(fieldNameLabelId) && StringUtils.isNumeric(fieldNameLabelId)) {
                        fieldName = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(fieldNameLabelId));
                    }
                    if (StringUtils.isNotBlank(oldrealvalue) && StringUtils.isNumeric(oldrealvalue)) {
                        oldvalue = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(oldrealvalue));
                    }
                    if (StringUtils.isNotBlank(newrealvalue) && StringUtils.isNumeric(newrealvalue)) {
                        newValue = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(newrealvalue));
                    }
                    if (count == 0) {
                        valuesChanges.add(String.format(valueChangeNewFormat(), fieldName, newValue));
                    } else {
                        valuesChanges.add(String.format(valueChangeFormat(), fieldName, oldvalue, newValue));
                    }

                }
                /*String values = "";
                if (valuesChange.length() > 3) {
                    values = valuesChange.substring(0, valuesChange.length() - 3);
                }*/

                map.put("valueschanges", valuesChanges);
            }

        }
    }

    public static String valueChangeNewFormat() {
        return "【%s】：%s";
    }

    public static String valueChangeFormat() {
        return "【%s】：" + SalaryI18nUtil.getI18nLabel(61695, "由") +
                "[%s] " + SalaryI18nUtil.getI18nLabel(61697, "改为") + " [%s]";
    }

    public static void changKey2Lower(List<Map> list) {

        List<Map> newList = new ArrayList<>();
        for (Map orgMap : list) {
            Map<String, Object> resultMap = new HashMap<>();

            if (orgMap == null || orgMap.isEmpty()) {
                newList.add(resultMap);
                continue;
            }

            Set<String> keySet = orgMap.keySet();
            for (String key : keySet) {
                resultMap.put(key != null ? key.toLowerCase() : "", orgMap.get(key));
            }
            newList.add(resultMap);
        }
        list.clear();
        list.addAll(newList);
    }

    /**
     * 查看详细表的数据
     *
     * @param list
     */
    public static Map<String, Object> switchDetailChangeValue(List<Map> list) {
        Map<String, Object> res = new HashMap<>();
        List<Map<String, Object>> lists = new ArrayList<>();
        HashMap<String, String> repeatTableName = new HashMap<>();
        CaseInsensitiveMap map = null;
        for (Map<String, Object> hashMap : list) {
            map = new CaseInsensitiveMap<>(hashMap);
            List<Map> detailmap = new ArrayList<>();
            HashMap<String, Object> detailoldMap = new HashMap<>();
            detailoldMap.put("operator", SalaryI18nUtil.getI18nLabel(63248, "操作(旧)"));
            detailoldMap.put("dataid", map.get("dataid"));
            HashMap<String, Object> detailnewMap = new HashMap<>();
            detailnewMap.put("operator", SalaryI18nUtil.getI18nLabel(63249, "操作(新)"));
            detailnewMap.put("dataid", map.get("dataid"));
            detailmap.add(detailoldMap);
            detailmap.add(detailnewMap);
            WeaTable wea = new WeaTable();
            wea.getColumns().add(new WeaTableColumn("5%",SalaryI18nUtil.getI18nLabel(63250, "操作"), "operator"));
//            wea.getColumns().add(new WeaTableColumn("dataid", "dataid", true));
            Object tablename = map.get("tablename");
            Object tablenamelabelid = map.get("tablenamelabelid");
            if (tablenamelabelid != null) {
                if (StringUtils.isNotBlank(tablenamelabelid.toString()) && StringUtils.isNumeric(tablenamelabelid.toString())) {
                    tablename = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(tablenamelabelid.toString()));
                }
            }
            Map<String, Object> m = new HashMap<>();
            if (tablename != null && StringUtils.isNotBlank(tablename.toString())) {
                String temptablename = repeatTableName.get(tablename.toString());
                if (tablename.toString().equals(temptablename)) {
                    continue;
                }
                repeatTableName.put(tablename.toString(), tablename.toString());
                m.put("tablename", tablename.toString());
                m.put("detailmap", detailmap);
                m.put("column", wea);
                lists.add(m);
            } else {
                tablename = tablename != null ? tablename : "";
                String temptablename = repeatTableName.get(tablename.toString());
                if (tablename.toString().equals(temptablename)) {
                    continue;
                }
                repeatTableName.put(tablename.toString(), tablename.toString());
                m.put("tablename", "");
                m.put("detailmap", detailmap);
                m.put("column", wea);
                lists.add(m);
            }
        }

        for (Map<String, Object> hashMap : list) {
            map = new CaseInsensitiveMap<>(hashMap);
            Object isDetail = map.get("isdetail");
            if (isDetail != null) {
                if ("0".equals(isDetail.toString())) {
                    continue;
                }
            } else {
                continue;
            }
            String title = "";
            String dataIndex = "";
            String oldValue = "";
            String newValue = "";
            String tableName = "";
            String dataId = "";

            Object fieldDesc = map.get("fielddesc");
            if (fieldDesc != null) {
                if (StringUtils.isNotBlank(fieldDesc.toString())) {
                    title = fieldDesc.toString();
                }
            }

            Object fieldnamelabelid = map.get("fieldnamelabelid");
            if (fieldnamelabelid != null) {
                if (StringUtils.isNotBlank(fieldnamelabelid.toString()) && StringUtils.isNumeric(fieldnamelabelid.toString())) {
                    title = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(fieldnamelabelid.toString()));
                }
            }

            Object fieldName = map.get("fieldname");
            if (fieldName != null) {
                if (StringUtils.isNotBlank(fieldName.toString())) {
                    dataIndex = fieldName.toString();
                }
            }
            Object oValue = map.get("oldvalue");
            if (oValue != null) {
                if (StringUtils.isNotBlank(oValue.toString())) {
                    oldValue = oValue.toString();
                }
            }
            Object nValue = map.get("newvalue");
            if (nValue != null) {
                if (StringUtils.isNotBlank(nValue.toString())) {
                    newValue = nValue.toString();
                }
            }
            Object oldRealValue = map.get("oldrealvalue");
            if (oldRealValue != null) {
                if (StringUtils.isNotBlank(oldRealValue.toString()) && StringUtils.isNumeric(oldRealValue.toString())) {
                    oldValue = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(oldRealValue.toString()));
                }
            }

            Object newrealvalue = map.get("newrealvalue");
            if (newrealvalue != null) {
                if (StringUtils.isNotBlank(newrealvalue.toString()) && StringUtils.isNumeric(newrealvalue.toString())) {
                    newValue = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(newrealvalue.toString()));
                }
            }

            Object tablename = map.get("tablename");
            if (StringUtils.isNotBlank(tablename.toString())) {
                tableName = tablename.toString();
            } else {
                tableName = "";
            }
            Object tablenamelabelid = map.get("tablenamelabelid");
            if (tablenamelabelid != null) {
                if (tablenamelabelid != null) {
                    if (StringUtils.isNotBlank(tablenamelabelid.toString()) && StringUtils.isNumeric(tablenamelabelid.toString())) {
                        tableName = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(tablenamelabelid.toString()));
                    }
                }
            }
            Object dataid = map.get("dataid");
            if (StringUtils.isNotBlank(dataid.toString())) {
                dataId = dataid.toString();
            } else {
                dataId = "";
            }
            for (Map<String, Object> m : lists) {
                Object o = m.get("tablename");
                if (o != null) {
                    if (tableName.equals(o)) {
                        List<Map> details = (List) m.get("detailmap");
                        List<Map> newDetails = new ArrayList<>();
                        if (details != null && details.size() > 0) {
                            for (Map detail : details) {
                                Object data_id = detail.get("dataid");
                                if (data_id != null) {
                                    if (dataId.equals(data_id)) {
                                        Object operator = detail.get("operator");
                                        if (operator != null) {
                                            if (SalaryI18nUtil.getI18nLabel(63248, "操作(旧)").equals(operator.toString())) {
                                                detail.put(dataIndex, oldValue);
                                            } else if (SalaryI18nUtil.getI18nLabel(63249, "操作(新)").equals(operator.toString())) {
                                                detail.put(dataIndex, newValue);
                                            }
                                        }
                                    } else {
                                        if (newDetails.size() > 2) {
                                            for (Map newDetail : newDetails) {
                                                if (dataId.equals(newDetail.get("dataid"))) {
                                                    Object operator = detail.get("operator");
                                                    if (operator != null) {
                                                        if (SalaryI18nUtil.getI18nLabel(63248, "操作(旧)").equals(operator.toString())) {
                                                            detail.put(dataIndex, oldValue);
                                                        } else if (SalaryI18nUtil.getI18nLabel(63249, "操作(新)").equals(operator.toString())) {
                                                            detail.put(dataIndex, newValue);
                                                        }
                                                    }
                                                } else {
                                                    HashMap<String, Object> detailoldMap = new HashMap<>();
                                                    detailoldMap.put("operator", SalaryI18nUtil.getI18nLabel(63248, "操作(旧)"));
                                                    detailoldMap.put("dataid", map.get("dataid"));
                                                    detailoldMap.put(dataIndex, oldValue);
                                                    HashMap<String, Object> detailnewMap = new HashMap<>();
                                                    detailnewMap.put("operator", SalaryI18nUtil.getI18nLabel(63249, "操作(新)"));
                                                    detailnewMap.put("dataid", map.get("dataid"));
                                                    detailnewMap.put(dataIndex, newValue);
                                                    newDetails.add(detailoldMap);
                                                    newDetails.add(detailnewMap);
                                                }
                                            }
                                        } else if (newDetails.size() == 0) {
                                            int count = 0;
                                            for (Map mapdetail : details) {
                                                Object dataid_ = mapdetail.get("dataid");
                                                if (dataid_ != null && dataid_.equals(dataId)) {
                                                    count++;
                                                }
                                            }
                                            if (count == 0) {
                                                HashMap<String, Object> detailoldMap = new HashMap<>();
                                                detailoldMap.put("operator", SalaryI18nUtil.getI18nLabel(63248, "操作(旧)"));
                                                detailoldMap.put("dataid", map.get("dataid"));
                                                detailoldMap.put(dataIndex, oldValue);
                                                HashMap<String, Object> detailnewMap = new HashMap<>();
                                                detailnewMap.put("operator", SalaryI18nUtil.getI18nLabel(63249, "操作(新)"));
                                                detailnewMap.put("dataid", map.get("dataid"));
                                                detailnewMap.put(dataIndex, newValue);
                                                newDetails.add(detailoldMap);
                                                newDetails.add(detailnewMap);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (newDetails.size() > 0) {
                            details.addAll(newDetails);
                            newDetails.clear();
                        }

                        WeaTable column = (WeaTable) m.get("column");
                        if (column != null) {
                            List columns = column.getColumns();
                            if (columns != null && columns.size() > 0) {
                                Boolean flag = true;
                                for (Object object : columns) {
                                    WeaTableColumn weaTableColumn = JSONObject.parseObject(JSON.toJSONString(object), WeaTableColumn.class);
                                    if (weaTableColumn != null) {
                                        String title1 = weaTableColumn.getText();
                                        if (title.equals(title1)) {
                                            flag = false;
                                            break;
                                        }
                                    }
                                }
                                if (flag) {
                                    column.getColumns().add(new WeaTableColumn(title, dataIndex, "5%"));
                                    m.put("column", column);
                                }
                            }
                        }
                    }
                }
            }
        }
        res.put("detail", lists);
        return res;
    }


    public static void switchDetailChangeValues(List<Map> list) {
        for (Map<String, Object> map : list) {
            Map<String, String> repeatTableName = new HashMap<>();
            List<Map> detailContexts = (List<Map>) map.get("detailcontexts");
            List<Map> lists = new ArrayList<>();
            if (detailContexts != null) {
                for (Map detailContext : detailContexts) {
                    List<Map> detailmap = new ArrayList<>();
                    HashMap<String, Object> detailoldMap = new HashMap<>();
                    detailoldMap.put("operator", SalaryI18nUtil.getI18nLabel(63248, "操作(旧)"));
                    detailoldMap.put("dataid", detailContext.get("dataid"));
                    HashMap<String, Object> detailnewMap = new HashMap<>();
                    detailnewMap.put("operator", SalaryI18nUtil.getI18nLabel(63249, "操作(新)"));
                    detailnewMap.put("dataid", detailContext.get("dataid"));
                    detailmap.add(detailoldMap);
                    detailmap.add(detailnewMap);
                    WeaTable wea = new WeaTable();
                    wea.getColumns().add(new WeaTableColumn(SalaryI18nUtil.getI18nLabel(63250, "操作"), "operator", "5%"));
//                    wea.getColumns().add(new WeaTableColumn("dataid", "dataid", true));
                    Object tableName = detailContext.get("tableName");
                    Object tablenamelabelid = detailContext.get("tableNameLabelId");
                    if (tablenamelabelid != null) {
                        if (StringUtils.isNotBlank(tablenamelabelid.toString()) && StringUtils.isNumeric(tablenamelabelid.toString())) {
                            tableName = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(tablenamelabelid.toString()));
                        }
                    }
                    Map<String, Object> m = new HashMap<>();
                    if (StringUtils.isNotBlank(tableName.toString())) {
                        String temptablename = repeatTableName.get(tableName.toString());
                        if (tableName.toString().equals(temptablename)) {
                            continue;
                        }
                        repeatTableName.put(tableName.toString(), tableName.toString());
                        m.put("tablename", tableName.toString());
                        m.put("detailmap", detailmap);
                        m.put("column", wea);
                        lists.add(m);
                        map.put("detail", lists);
                    } else {
                        String temptablename = repeatTableName.get(tableName.toString());
                        if (tableName.toString().equals(temptablename)) {
                            continue;
                        }
                        repeatTableName.put(tableName.toString(), tableName.toString());
                        m.put("tablename", "");
                        m.put("detailmap", detailmap);
                        m.put("column", wea);
                        lists.add(m);
                        map.put("detail", lists);
                    }
                }
            }
            List<Map> details = (List) map.get("detail");
            if (details != null) {
                int size = details.size();
                int start = 0;
                while (start < size) {
                    start++;

                    for (int i = 0; i < size; i++) {
                        Map detail = details.get(i);

                        //for (Map detail : details) {
                        if (details.size() > size) {
                            break;
                        }
                        for (Map detailContext : detailContexts) {
                            Object isDetail = detailContext.get("isDetail");
                            if (isDetail != null) {
                                if ("0".equals(isDetail.toString())) {
                                    continue;
                                }
                            } else {
                                continue;
                            }
                            String title = "";
                            String dataIndex = "";
                            String oldValue = "";
                            String newValue = "";
                            String tableName = "";
                            String dataId = "";
                            Object fieldDesc = detailContext.get("fieldDesc");
                            if (StringUtils.isNotBlank(fieldDesc.toString())) {
                                title = fieldDesc.toString();
                            }
                            Object fieldnamelabelid = detailContext.get("fieldNameLabelId");
                            if (fieldnamelabelid != null) {
                                if (StringUtils.isNotBlank(fieldnamelabelid.toString()) && StringUtils.isNumeric(fieldnamelabelid.toString())) {
                                    title = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(fieldnamelabelid.toString()));
                                }
                            }
                            Object fieldName = detailContext.get("fieldName");
                            if (StringUtils.isNotBlank(fieldName.toString())) {
                                dataIndex = fieldName.toString();
                            }
                            Object oValue = detailContext.get("oldValue");
                            if (StringUtils.isNotBlank(oValue.toString())) {
                                oldValue = oValue.toString();
                            }
                            Object nValue = detailContext.get("newValue");
                            if (StringUtils.isNotBlank(nValue.toString())) {
                                newValue = nValue.toString();
                            }
                            Object oldRealValue = detailContext.get("oldRealValue");
                            if (oldRealValue != null) {
                                if (StringUtils.isNotBlank(oldRealValue.toString()) && StringUtils.isNumeric(oldRealValue.toString())) {
                                    oldValue = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(oldRealValue.toString()));
                                }
                            }

                            Object newrealvalue = detailContext.get("newRealValue");
                            if (newrealvalue != null) {
                                if (StringUtils.isNotBlank(newrealvalue.toString()) && StringUtils.isNumeric(newrealvalue.toString())) {
                                    newValue = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(newrealvalue.toString()));
                                }
                            }
                            Object tablename = detailContext.get("tableName");
                            if (StringUtils.isNotBlank(tablename.toString())) {
                                tableName = tablename.toString();
                            } else {
                                tableName = "";
                            }
                            Object tablenamelabelid = detailContext.get("tableNameLabelId");
                            if (tablenamelabelid != null) {
                                if (tablenamelabelid != null) {
                                    if (StringUtils.isNotBlank(tablenamelabelid.toString()) && StringUtils.isNumeric(tablenamelabelid.toString())) {
                                        tableName = ElogSeviceSwitchUtils.transfLanguageLableid(Long.parseLong(tablenamelabelid.toString()));
                                    }
                                }
                            }
                            Object dataid = detailContext.get("dataid");
                            if (StringUtils.isNotBlank(dataid.toString())) {
                                dataId = dataid.toString();
                            } else {
                                dataId = "";
                            }
                            Object detailtablename = detail.get("tablename");
                            if (detailtablename != null) {
                                if (tableName.equals(detailtablename.toString())) {
                                    List<Map> detailmap = (List) detail.get("detailmap");
                                    List<Map> newDetails = new ArrayList<>();
                                    if (detailmap != null && detailmap.size() > 0) {
                                        for (Map d : detailmap) {
                                            Object data_id = d.get("dataid");
                                            if (data_id != null) {
                                                if (dataId.equals(data_id)) {
                                                    Object operator = d.get("operator");
                                                    if (operator != null) {
                                                        if (SalaryI18nUtil.getI18nLabel(63248, "操作(旧)").equals(operator.toString())) {
                                                            d.put(dataIndex, oldValue);
                                                        } else if (SalaryI18nUtil.getI18nLabel(63249, "操作(新)").equals(operator.toString())) {
                                                            d.put(dataIndex, newValue);
                                                        }
                                                    }
                                                } else {
                                                    if (newDetails.size() > 2) {
                                                        for (Map newDetail : newDetails) {
                                                            if (dataId.equals(newDetail.get("dataid"))) {
                                                                Object operator = d.get("operator");
                                                                if (operator != null) {
                                                                    if (SalaryI18nUtil.getI18nLabel(63248, "操作(旧)").equals(operator.toString())) {
                                                                        d.put(dataIndex, oldValue);
                                                                    } else if (SalaryI18nUtil.getI18nLabel(63249, "操作(新)").equals(operator.toString())) {
                                                                        d.put(dataIndex, newValue);
                                                                    }
                                                                }
                                                            } else {
                                                                HashMap<String, Object> detailoldMap = new HashMap<>();
                                                                detailoldMap.put("operator", SalaryI18nUtil.getI18nLabel(63248, "操作(旧)"));
                                                                detailoldMap.put("dataid", detailContext.get("dataid"));
                                                                detailoldMap.put(dataIndex, oldValue);
                                                                HashMap<String, Object> detailnewMap = new HashMap<>();
                                                                detailnewMap.put("operator", SalaryI18nUtil.getI18nLabel(63249, "操作(新)"));
                                                                detailnewMap.put("dataid", detailContext.get("dataid"));
                                                                detailnewMap.put(dataIndex, newValue);
                                                                newDetails.add(detailoldMap);
                                                                newDetails.add(detailnewMap);
                                                            }
                                                        }
                                                    } else if (newDetails.size() == 0) {
                                                        int count = 0;
                                                        for (Map mapdetail : detailmap) {
                                                            Object dataid_ = mapdetail.get("dataid");
                                                            if (dataid_ != null && dataid_.equals(dataId)) {
                                                                count++;
                                                            }
                                                        }
                                                        if (count == 0) {
                                                            HashMap<String, Object> detailoldMap = new HashMap<>();
                                                            detailoldMap.put("operator", SalaryI18nUtil.getI18nLabel(63248, "操作(旧)"));
                                                            detailoldMap.put("dataid", detailContext.get("dataid"));
                                                            detailoldMap.put(dataIndex, oldValue);
                                                            HashMap<String, Object> detailnewMap = new HashMap<>();
                                                            detailnewMap.put("operator", SalaryI18nUtil.getI18nLabel(63249, "操作(新)"));
                                                            detailnewMap.put("dataid", detailContext.get("dataid"));
                                                            detailnewMap.put(dataIndex, newValue);
                                                            newDetails.add(detailoldMap);
                                                            newDetails.add(detailnewMap);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (newDetails.size() > 0) {
                                        details.addAll(newDetails);
                                        newDetails.clear();
                                        //detailmap = new ArrayList<>();
                                        //detail.put("detailmap", detailmap);
                                    }

                                    WeaTable column = (WeaTable) detail.get("column");
                                    if (column != null) {
                                        List columns = column.getColumns();
                                        if (columns != null && columns.size() > 0) {
                                            Boolean flag = true;
                                            for (Object object : columns) {
                                                WeaTableColumn weaTableColumn = JSONObject.parseObject(JSON.toJSONString(object), WeaTableColumn.class);
                                                if (weaTableColumn != null) {
                                                    String title1 = weaTableColumn.getText();
                                                    if (title.equals(title1)) {
                                                        flag = false;
                                                        break;
                                                    } else {
                                                        flag = true;
                                                    }
                                                }
                                            }
                                            if (flag) {
                                                column.getColumns().add(new WeaTableColumn(title, dataIndex, "5%"));
                                                detail.put("column", column);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    public static List getSwitchDatabaseData(List<Map> list) {
        String databaseId = new RecordSet().getDBType();
        if (ElogConsts.ORACLE.equalsIgnoreCase(databaseId) || ElogConsts.SQLSERVER.equalsIgnoreCase(databaseId)) {
            List<Map> arrayList = new ArrayList<>();
            for (Map map : list) {
                Set<Map.Entry> en = map.entrySet();
                Map<Object, Object> hashMap = new HashMap<>();
                for (Map.Entry entry : en) {
                    Object key = entry.getKey();
                    Object val = null;
                    if ("PARAMS".equalsIgnoreCase(key.toString()) || "CUSTOMINFO".equalsIgnoreCase(key.toString())
                            || entry.getValue() instanceof ClobProxyImpl || entry.getValue() instanceof Clob) {
                        val = JSONObject.toJSON(entry.getValue());
                    } else {
                        val = entry.getValue();
                    }
                    hashMap.put(key.toString().toLowerCase(), val);
                }
                switchDatabaseField(hashMap);
                arrayList.add(hashMap);
            }
            return arrayList;
        } else {
            for (Map map : list) {
                switchDatabaseField(map);
            }
            return list;
        }
    }

    public static List getSwitchDatabaseAnalysisData(List<Map> list, Map<String, String> keys) {
        String databaseId = new RecordSet().getDBType();
        if (!ElogConsts.MYSQL.equalsIgnoreCase(databaseId)) {
            List<Map> arrayList = new ArrayList<>();

            for (Map map : list) {
                Set<Map.Entry> en = map.entrySet();
                Map<Object, Object> hashMap = new HashMap<>();
                for (Map.Entry entry : en) {
                    Object key = entry.getKey();
                    Object val = entry.getValue();
                    if (key.toString().equalsIgnoreCase(keys.get(key.toString().toLowerCase()))) {
                        key = keys.get(key.toString().toLowerCase());
                    } else {
                        key = key.toString().toLowerCase();
                    }
                    hashMap.put(key.toString(), val);
                }
                arrayList.add(hashMap);
            }
            return arrayList;
        }
        return list;
    }

    /**
     * 获取多个模块名称
     *
     * @param modules
     * @return
     */
    public static Map getModuleNames(List<String> modules) {
        Map<String, Object> hashMap = new HashMap<>();
        if (modules == null || modules.size() == 0) {
            return hashMap;
        }
        for (String module : modules) {
            String modulenum = ElogSeviceUtils.null2String(moduleMap.get(module), module);
            String modulename = ElogSeviceUtils.isLongValue(modulenum) ? SalaryI18nUtil.getI18nLabel(Integer.parseInt(modulenum), modulenum) : modulenum;
            hashMap.put(module, modulename);
        }
        return hashMap;

    }

//    private static String StringConversionForXSS(String str) {
//        if (StringUtils.isBlank(str))
//            return str;
//        //判断是否是json串 是json串的话也直接返回
//        if (isJSONString(str))
//            return str;
//        // 判断是否为前端标签类型字符串或带< 或 >的字符串，用false方法  /<(\\w+)[^>]*>(.*?<\\/\\1>)?/
//        Pattern pattern = Pattern.compile("[<>]");
//        Matcher matcher = pattern.matcher(str);
//        if (matcher.find())
//            return SecurityUtil.encodeForHtml(str, false);
//        //都不是则用true方法
//        return SecurityUtil.encodeForHtml(str, true);
//
//    }


    /**
     * 判断是否为json字符串
     *
     * @param content
     * @return
     */
    public static boolean isJSONString(String content) {
        if (StringUtils.isEmpty(content)) {
            return false;
        }
        if (!content.startsWith("{") || !content.endsWith("}")) {
            if (!content.startsWith("[") || !content.endsWith("]")) {
                return false;
            }
        }
        try {
            JSONObject.parse(content);
            return true;
        } catch (Exception e) {
            return false;
        }
    }

    public static List<String> getNameModule(String module) {
        if (StringUtils.isBlank(module)) {
            return new ArrayList<>();
        }
        Map<String, List<String>> dataMap = new HashMap<>();
        moduleMap.forEach((k, v) -> {
            List<String> list = new ArrayList<>();
            Integer moduleCode = moduleMap.get(k);
            String htmlLabelName = SalaryI18nUtil.getI18nLabel(moduleCode, "");
            if (dataMap.containsKey(htmlLabelName)) {
                list = dataMap.get(htmlLabelName);
                list.add(k);
            } else {
                list.add(k);
            }
            dataMap.put(htmlLabelName, list);
        });
        return Objects.isNull(dataMap.get(module)) ? Arrays.asList(module) : dataMap.get(module);
    }
}
