package com.engine.salary.elog.util;

import org.apache.commons.lang3.StringUtils;

import java.util.HashMap;
import java.util.Map;

/**
 * @ClassName: FieldNameMap
 * @Description TODO
 * @Author tanghj
 * @Date 2021/3/31 14:27
 */
public class FieldNameMap {

    private static Map<String, String> mainFieldNameMap = new HashMap<>();

    private static Map<String, String> detailFieldNameMap = new HashMap<>();

    private static Map<String, Map<String, String>> mainCusFieldNameMap = new HashMap<>();

    private static Map<String, Map<String, String>> detailCusFieldNameMap = new HashMap<>();


    public static void setMainFieldName(Map<String, String> fieldNameMap) {
        mainFieldNameMap.putAll(fieldNameMap);
    }

    public static void setDetailFieldName(Map<String, String> fieldNameMap) {
        detailFieldNameMap.putAll(fieldNameMap);
    }

    public static void setMainCusFieldName(String module, String function, Map<String, String> fieldNameMap) {
        mainCusFieldNameMap.put(getKey(module, function), fieldNameMap);
    }

    public static void setDetailCusFieldName(String module, String function, Map<String, String> fieldNameMap) {
        detailCusFieldNameMap.put(getKey(module, function), fieldNameMap);
    }


    public static String getMainFieldNameMap(String module, String function, String key) {

        String str = key.toLowerCase();
        if(mainFieldNameMap.containsKey(str)) {
            return  StringUtils.isNotEmpty(mainFieldNameMap.get(str)) ? mainFieldNameMap.get(str) : key;
        } else {
            return getMainCusFieldNameMap(module, function,key);
        }
    }

    public static String getDetailFieldNameMap(String module, String function, String key) {
        key = key.toLowerCase();
        if(detailFieldNameMap.containsKey(key)) {
            return  StringUtils.isNotEmpty(detailFieldNameMap.get(key)) ? detailFieldNameMap.get(key) : key;
        } else {
            return getDetailCusFieldNameMap(module, function, key);
        }
    }

    public static String getMainCusFieldNameMap(String module, String function, String key) {

        if(mainCusFieldNameMap.containsKey(getKey(module, function))) {
            if(mainCusFieldNameMap.get(getKey(module, function)).containsKey(key)) {
                return StringUtils.isNotEmpty(mainCusFieldNameMap.get(getKey(module, function)).get(key)) ?
                        mainCusFieldNameMap.get(getKey(module, function)).get(key) :
                        key;
            } else {
                return key;
            }
        } else {
            return key;
        }
    }

    public static String getDetailCusFieldNameMap(String module, String function, String key) {

        if(detailCusFieldNameMap.containsKey(getKey(module, function))) {
            if(detailCusFieldNameMap.get(getKey(module, function)).containsKey(key)) {
                return StringUtils.isNotEmpty(detailCusFieldNameMap.get(getKey(module, function)).get(key)) ?
                        detailCusFieldNameMap.get(getKey(module, function)).get(key) :
                        key;
            } else {
                return key;
            }
        } else {
            return key;
        }
    }

    private static String getKey(String module, String function) {
        return module + "@" + function;
    }
}
