package com.engine.salary.elog.util;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.parser.Feature;
import com.alibaba.fastjson.serializer.SerializerFeature;

import com.engine.salary.elog.annotation.ElogTransform;
import com.engine.salary.elog.async.LoggerMessageListener;
import com.engine.salary.elog.entity.dto.LoggerContext;
import com.engine.salary.elog.entity.dto.LoggerDetailContext;
import com.engine.salary.elog.entity.dto.TableChangeBean;
import com.engine.salary.elog.util.db.IdGenerator;
import com.engine.salary.elog.annotation.ApiModel;
import com.engine.salary.elog.annotation.ApiModelProperty;
import org.apache.commons.lang3.ArrayUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import weaver.hrm.User;

import java.lang.reflect.Field;
import java.util.*;

/**
 * @ClassName: LoggerTemplate
 * @Description 日志基本功能类
 * @Author tanghj
 * @Date 2021/2/10 14:18
 */
//@Component
public class LoggerTemplate {
    protected String function = "common";

    protected String module;

    protected String logCenterQueue = "Elog_cneterlogQueue";

    public static final String AUDITLOGQUEUE = "AuditLog";
    public static final String ELOG = "Elog";

    protected String localQueue;

    protected String moduleName;

    protected static String applicationName;

    public void setApplicationName(String applicationName) {
        LoggerTemplate.applicationName = applicationName;
    }

    public String getApplicationName() {
        return applicationName;
    }

    private static final Logger logger = LoggerFactory.getLogger(LoggerTemplate.class);

    protected static String publishkitGroup;

    public void setPublishkitGroup(String publishkitGroup) {
        LoggerTemplate.publishkitGroup = publishkitGroup;
    }

    public String getPublishkitGroup() {
        return publishkitGroup;
    }


    LoggerMessageListener loggerMessageListener = new LoggerMessageListener();

    /**
     * 写入日志消息队列
     *
     * @param context 日志实体
     */
    public void write(LoggerContext context) {
        this.write(context, true);
    }

    /**
     * 写入日志消息队列
     *
     * @param context 日志实体
     * @param isLocal true 存储本地， false不存储本地
     */
    public void write(LoggerContext context, boolean isLocal) {
        String elogLocalQueue = ELOG + this.applicationName;
        if (StringUtils.isEmpty(this.localQueue)) {
            this.localQueue = (StringUtils.isNotEmpty(this.moduleName) ? this.moduleName : elogLocalQueue) + "LocalQueue" + this.publishkitGroup;
        }
        try {
            handleContext(context);
        } catch (Exception e) {
            logger.error("handleContext方法异常！{}", e.getMessage(), e);
        }
        loggerMessageListener.receiveold(context);

    }

//    public void writeLocal(LoggerContext context){
//        String elogLocalQueue =  ELOG + this.applicationName;
//        if(StringUtils.isEmpty(this.localQueue))
//            this.localQueue = (StringUtils.isNotEmpty(this.moduleName) ? this.moduleName : elogLocalQueue) + "LocalQueue" + this.publishkitGroup;
//        AsyncBean<LoggerContext> asyncBean = new AsyncBean<>();
//        handleContext(context);
//        if (context.getWeakElogReocrd() && CollectionUtils.isEmpty(context.getDetailContexts() )) {
//            logger.info("日志弱控且没有明细记录，不记录日志,modulename:{},functionname:{}",context.getModuleName(),context.getFunctionName());
//            return;
//        }
//
//        try {
//            asyncBean.setMessage(context);
//            asyncBean.setQueue(localQueue);
//            asyncClient.send(asyncBean);
//        } catch (Exception e) {
//            logger.error("发送writeLocal-mq消息异常！{}",e.getMessage(),e);
//        }
//    }


//    public void checkAsyncBean(AsyncBean asyncBean) {
//        int length = JSON.toJSON(asyncBean).toString().getBytes(StandardCharsets.UTF_8).length / 1000;
//        boolean checkPass = length <= 5120;
//        if (!checkPass)
//            throw new RuntimeException("消息体超出5M，不支持发送!");
//    }

//    /**
//     *  没有明细变化可以不写入日志
//     * @param context 日志信息
//     * @param isLocal 是否写入本地
//     * @param notChangeDetailSendLog 没有明细变化不写入日志
//     */
//    public void write(LoggerContext context, boolean isLocal,boolean notChangeDetailSendLog){
//        String elogLocalQueue =  ELOG + this.applicationName;
//        if(StringUtils.isEmpty(this.localQueue))
//            this.localQueue = (StringUtils.isNotEmpty(this.moduleName) ? this.moduleName : elogLocalQueue) + "LocalQueue";
//        AsyncBean<LoggerContext> asyncBean = new AsyncBean<>();
//        handleContext(context);
//
//        if (notChangeDetailSendLog && (context.getDetailContexts() == null || context.getDetailContexts().size() == 0)) {
//            return;
//        }
//        try {
//            asyncBean.setMessage(context);
//            asyncBean.setQueue(logCenterQueue);
//            asyncClient.send(asyncBean);
//            writeHrmLog(context);
//            if(isLocal) {
//                asyncBean.setQueue(localQueue);
//                asyncClient.send(asyncBean);
//            }
//        } catch (Exception e) {
//            logger.error("发送mq消息异常！{}",e.getMessage(),e);
//        }
//
//    }

//    /**
//     * 支持了向其他模块服务发送业务日志
//     * @param context
//     * @param isLocal
//     * @param moduleName
//     */
//    public void write(LoggerContext context, boolean isLocal, String moduleName){
//
//        if(StringUtils.isNotEmpty(moduleName)) {
//            String localQueue = moduleName + "LocalQueue";
//            // context.setModuleName(moduleName);
//            AsyncBean<LoggerContext> asyncBean = new AsyncBean<>();
//            handleContext(context);
//            try {
//                asyncBean.setMessage(context);
//                asyncBean.setQueue(logCenterQueue);
//                asyncClient.send(asyncBean);
//                writeHrmLog(context);
//                if(isLocal) {
//                    asyncBean.setQueue(localQueue);
//                    asyncClient.send(asyncBean);
//                }
//            } catch (Exception e) {
//                logger.error("发送mq消息异常！:{}",e.getMessage());
//            }
//        } else {
//            write(context, isLocal);
//        }
//
//    }

//    public void writeHrmLog(LoggerContext context) {
//        AsyncBean<LoggerContext> asyncBean = new AsyncBean<>();
//        handleContext(context);
//        asyncBean.setMessage(context);
//        //asyncBean.setTopic(WRITEAUDITLOGTOPIC);
//        asyncBean.setQueue(AUDITLOGQUEUE);
//        asyncClient.send(asyncBean);
//
//    }

//    /**
//     * 支持了向其他模块服务发送业务日志
//     * @param context
//     * @param isLocal
//     * @param moduleName
//     */
//    public void write(LoggerContext context, boolean isLocal, String moduleName,String functionName,String queueName){
//
//        if (StringUtils.isNotEmpty(moduleName) && StringUtils.isNotEmpty(functionName)) {
//            context.setModuleName(moduleName);
//            context.setFunctionName(functionName);
//            this.localQueue = queueName + "LocalQueue";
//            AsyncBean<LoggerContext> asyncBean = new AsyncBean<>();
//            handleContext(context);
//            try {
//                asyncBean.setMessage(context);
//                asyncBean.setQueue(logCenterQueue);
//                asyncClient.send(asyncBean);
//                writeHrmLog(context);
//                if (isLocal) {
//                    asyncBean.setQueue(localQueue);
//                    asyncClient.send(asyncBean);
//                }
//            } catch (Exception e) {
//                logger.error("发送mq消息异常！,{}！",e);
//            }
//        } else {
//            write(context, isLocal);
//        }
//
//    }

    private void handleContext(LoggerContext context) {
        if (StringUtils.isEmpty(context.getModuleName())) {
            context.setModuleName(module);
        }
        if (StringUtils.isEmpty(context.getFunctionName())) {
            context.setFunctionName(function);
        }
        if (!(context.getId() > 0)) {
            context.setId(IdGenerator.generate());
        }
        if (StringUtils.isEmpty(context.getUuid())) {
            context.setUuid(UUID.randomUUID().toString().replace("-", ""));
        }

        context.setTempParams(null);
        String employeeId = Optional.ofNullable(context.getUser()).map(User::getUID).orElse(0).toString();
        String tenantKey = "all_teams";
        String userName = Optional.ofNullable(context.getUser()).map(User::getUsername).orElse("").toString();
        if (StringUtils.isEmpty(context.getOperator()) && StringUtils.isNotEmpty(employeeId)) {
            context.setOperator(employeeId + "");
        }
        if (StringUtils.isEmpty(context.getTenant_key()) && StringUtils.isNotEmpty(tenantKey)) {
            context.setTenant_key(tenantKey);
        }
        if (StringUtils.isEmpty(context.getOperatorName()) && StringUtils.isNotEmpty(userName)) {
            context.setOperatorName(userName);
        }
        //}

        if (StringUtils.isBlank(context.getOperator()) || "null".equals(context.getOperator())) {
            context.setOperator("-1");
        }
        if (StringUtils.isBlank(context.getTargetId()) || "null".equals(context.getTargetId())) {
            context.setTargetId("-1");
        }

//        RequestAttributes requestAttributes = SalaryContext.get().getRequestAttributesSafely();
//        if ((requestAttributes instanceof ServletRequestAttributes)) {
//            HttpServletRequest request = ((ServletRequestAttributes) requestAttributes).getRequest();
//            ElogUtils.initRequestInfo(request, context);
//        } else {
//            if (StringUtils.isEmpty(context.getRequestUrl())) {
//                context.setRequestUrl("非http请求");
//            }
//            ElogUtils.initRpcInfo(context);
//        }
        ElogUtils.initRpcInfo(context);

        List<TableChangeBean> changeBeans = context.getChangeValues();

        List<LoggerDetailContext> valueChangeList = new ArrayList<>();
        int showOrder = 0;
        if (changeBeans != null) {
            for (TableChangeBean changeBean : changeBeans) {
                if (changeBean != null && (changeBean.getNewValue() != null || changeBean.getOldValue() != null)) {
                    String uuid = UUID.randomUUID().toString().replace("-", "");
                    ApiModel apiModel = null;
                    ElogTransform tableTransform = null;
                    JSONObject newJo = new JSONObject();
                    JSONObject oldJo = new JSONObject();
                    JSONObject valueChange = JSONObject.parseObject(JSONObject.toJSONString(changeBean, SerializerFeature.WriteDateUseDateFormat), Feature.OrderedField);
                    Field[] fields = null;
                    if (changeBean.getNewValue() != null) {
                        apiModel = changeBean.getNewValue().getClass().getAnnotation(ApiModel.class);
                        tableTransform = changeBean.getNewValue().getClass().getAnnotation(ElogTransform.class);
                        //fields = changeBean.getNewValue().getClass().getDeclaredFields();
                        fields = getAllFields(changeBean.getNewValue().getClass());
                        newJo = valueChange.getJSONObject("newValue");
                    } else {
                        apiModel = changeBean.getOldValue().getClass().getAnnotation(ApiModel.class);
                        tableTransform = changeBean.getOldValue().getClass().getAnnotation(ElogTransform.class);
                        //fields = changeBean.getOldValue().getClass().getDeclaredFields();
                        fields = getAllFields(changeBean.getOldValue().getClass());
                    }
                    if (changeBean.getOldValue() != null) {
                        oldJo = valueChange.getJSONObject("oldValue");
                    }
                    if ((apiModel != null || tableTransform != null) && fields != null) {

                        for (Field field : fields) {
                            if (StringUtils.isEmpty(newJo.getString(field.getName())) && StringUtils.isEmpty(oldJo.getString(field.getName()))) {
                                continue;
                            }
                            if (StringUtils.isNotEmpty(newJo.getString(field.getName())) && newJo.getString(field.getName()).equals(oldJo.getString(field.getName()))) {
                                continue;
                            }

                            ApiModelProperty apiModelProperty = field.getAnnotation(ApiModelProperty.class);
                            ElogTransform fieldElogTransform = field.getAnnotation(ElogTransform.class);
                            LoggerDetailContext valueChangeBean = new LoggerDetailContext();
                            if (fieldElogTransform != null && fieldElogTransform.ignore()) {
                                continue;
                            }

                            //todo 若analyticList为true 且 新旧值属于JSONArray 解析List<T>
                            if (fieldElogTransform != null && fieldElogTransform.analyticList() && fieldElogTransform.analyticListClass() != void.class) {
                                analyticListMethod(field, newJo, oldJo, valueChangeList, fieldElogTransform);
                                continue;
                            }

                            valueChangeBean.setUuid(uuid);
                            valueChangeBean.setTableName(tableTransform != null && StringUtils.isNotEmpty(tableTransform.name()) ? tableTransform.name() : changeBean.getTableName());
                            valueChangeBean.setTableNameDesc(tableTransform != null && StringUtils.isNotEmpty(tableTransform.tablename()) ? tableTransform.tablename() : "");
                            valueChangeBean.setTableNameLabelId(tableTransform != null && tableTransform.labelId() != -1 ? tableTransform.labelId() + "" : "");
                            valueChangeBean.setIsDetail(changeBean.getIsDetail());
                            valueChangeBean.setFieldName(field.getName());
                            valueChangeBean.setFieldDesc(fieldElogTransform != null ? fieldElogTransform.name() : apiModelProperty != null ? apiModelProperty.value() : field.getName());
                            valueChangeBean.setFieldNameLabelId(fieldElogTransform != null ? fieldElogTransform.labelId() + "" : "-1");
                            valueChangeBean.setDataid(StringUtils.isNotEmpty(changeBean.getDataid()) ? changeBean.getDataid() :
                                    StringUtils.isNoneEmpty(newJo.getString("id")) ? newJo.getString("id") : oldJo.getString("id"));
                            valueChangeBean.setBelongDataid(StringUtils.isNotEmpty(changeBean.getBelongDataid()) ? changeBean.getBelongDataid() : "");

                            valueChangeBean.setNewValue(newJo.getString(field.getName()));
                            valueChangeBean.setOldValue(oldJo.getString(field.getName()));
                            valueChangeBean.setCreator(-1L);
                            try {
                                extracted(newJo, oldJo, field, fieldElogTransform, valueChangeBean);
                            } catch (Exception e) {
                                logger.error("转换出错:{}", e);
                                //System.out.println("转换出错：" + e.getMessage());
                            }


                            valueChangeBean.setShoworder(showOrder++);
                            valueChangeList.add(valueChangeBean);
                        }
                    } else {
                        Set<String> keys = new HashSet<>();
                        for (String key : (Set<String>) newJo.keySet()) {
                            keys.add(key);
                            if (newJo.getString(key).equals(oldJo.getString(key))) {
                                continue;
                            }
                            LoggerDetailContext valueChangeBean = new LoggerDetailContext();
                            valueChangeBean.setUuid(uuid);
                            valueChangeBean.setTableName(changeBean.getTableName());
                            valueChangeBean.setIsDetail(changeBean.getIsDetail());
                            valueChangeBean.setDataid(StringUtils.isNotEmpty(changeBean.getDataid()) ? changeBean.getDataid() :
                                    StringUtils.isNoneEmpty(newJo.getString("id")) ? newJo.getString("id") : oldJo.getString("id"));
                            valueChangeBean.setBelongDataid(StringUtils.isNotEmpty(changeBean.getBelongDataid()) ? changeBean.getBelongDataid() : "");
                            valueChangeBean.setFieldName(key);
                            valueChangeBean.setFieldDesc(key);
                            valueChangeBean.setNewValue(newJo.getString(key));
                            valueChangeBean.setOldValue(oldJo.getString(key));
                            valueChangeBean.setShoworder(showOrder++);
                            valueChangeBean.setCreator(-1L);
                            valueChangeList.add(valueChangeBean);
                        }
                        for (String key : (Set<String>) oldJo.keySet()) {
                            if (keys.contains(key)) {
                                continue;
                            }
                            keys.add(key);
                            if (oldJo.getString(key).equals(newJo.getString(key))) {
                                continue;
                            }
                            LoggerDetailContext valueChangeBean = new LoggerDetailContext();
                            valueChangeBean.setTableName(changeBean.getTableName());
                            valueChangeBean.setIsDetail(changeBean.getIsDetail());
                            valueChangeBean.setFieldName(key);
                            valueChangeBean.setFieldDesc(key);
                            valueChangeBean.setNewValue(newJo.getString(key));
                            valueChangeBean.setOldValue(oldJo.getString(key));
                            valueChangeBean.setShoworder(showOrder++);
                            valueChangeBean.setCreator(-1L);
                            valueChangeList.add(valueChangeBean);
                        }
                    }
                }
            }
        }

        if (valueChangeList.size() > 0) {
            context.setDetailContexts(valueChangeList);
        }
    }


    private void analyticListMethod(Field field, JSONObject newJo, JSONObject oldJo, List<LoggerDetailContext> valueChangeList, ElogTransform tableTransform) {
        JSONArray newValueArr = newJo.get(field.getName()) == null ? new JSONArray() : (JSONArray) newJo.get(field.getName());
        JSONArray oldvalueArr = oldJo.get(field.getName()) == null ? new JSONArray() : (JSONArray) oldJo.get(field.getName());
        Field[] allFields = getAllFields(tableTransform.analyticListClass());


        Boolean oldvalueIsNull = false;
        Boolean newvalueIsNull = false;

        if (oldvalueArr.size() == 0) {
            oldvalueIsNull = true;
        }
        if (newValueArr.size() == 0) {
            newvalueIsNull = true;
        }
        if ((oldvalueIsNull && newvalueIsNull) || (!oldvalueIsNull && !newvalueIsNull && oldvalueArr.size() != newValueArr.size())) {
            //如果新、旧没值或新旧值list数量对不上 直接返回
            return;
        }

        JSONArray foreachArr = oldvalueIsNull ? newValueArr : oldvalueArr;

        //遍历list
        for (int i = 0; i < foreachArr.size(); i++) {
            //默认另一个list关系是一一对应的
            JSONObject oldValue = oldvalueIsNull ? new JSONObject() : (JSONObject) oldvalueArr.get(i);
            JSONObject newValue = newvalueIsNull ? new JSONObject() : (JSONObject) newValueArr.get(i);

            //dataid uuid showOrder
            long dataid = IdGenerator.generate();
            String uuid = UUID.randomUUID().toString().replace("-", "");
            int showOrder = 0;

            //遍历字段
            for (Field allField : allFields) {
                if (StringUtils.isEmpty(newValue.getString(allField.getName())) && StringUtils.isEmpty(oldValue.getString(allField.getName()))) {
                    continue;
                }
                if (StringUtils.isNotEmpty(newValue.getString(allField.getName())) && newValue.getString(allField.getName()).equals(oldValue.getString(allField.getName()))) {
                    continue;
                }

                ApiModelProperty apiModelProperty = allField.getAnnotation(ApiModelProperty.class);
                ElogTransform fieldElogTransform = allField.getAnnotation(ElogTransform.class);
                LoggerDetailContext valueChangeBean = new LoggerDetailContext();

                valueChangeBean.setUuid(uuid);
                valueChangeBean.setTableName(tableTransform != null && StringUtils.isNotEmpty(tableTransform.name()) ? tableTransform.name() : field.getName());
                valueChangeBean.setTableNameDesc(tableTransform != null && StringUtils.isNotEmpty(tableTransform.tablename()) ? tableTransform.tablename() : "");
                valueChangeBean.setTableNameLabelId(tableTransform != null && tableTransform.labelId() != -1 ? tableTransform.labelId() + "" : "");
                valueChangeBean.setIsDetail(1);
                valueChangeBean.setFieldName(allField.getName());
                valueChangeBean.setNewValue(newValue.getString(allField.getName()));
                valueChangeBean.setOldValue(oldValue.getString(allField.getName()));
                valueChangeBean.setCreator(-1L);
                valueChangeBean.setBelongDataid("");
                valueChangeBean.setDataid(String.valueOf(dataid));

                if (fieldElogTransform != null) {
                    if (fieldElogTransform.ignore()) {
                        continue;
                    }

                    valueChangeBean.setFieldDesc(fieldElogTransform != null ? fieldElogTransform.name() : apiModelProperty != null ? apiModelProperty.value() : field.getName());
                    valueChangeBean.setFieldNameLabelId(fieldElogTransform != null ? fieldElogTransform.labelId() + "" : "-1");

                    try {
                        extracted(newValue, oldValue, allField, fieldElogTransform, valueChangeBean);
                    } catch (Exception e) {
                        logger.error("转换出错", e);
                        //System.out.println("转换出错：" + e.getMessage());
                    }

                    valueChangeBean.setShoworder(showOrder++);
                } else {
                    valueChangeBean.setFieldDesc(allField.getName());
                    valueChangeBean.setShoworder(showOrder++);

                }
                valueChangeList.add(valueChangeBean);
            }
        }
    }

    private void extracted(JSONObject newJo, JSONObject oldJo, Field field, ElogTransform fieldElogTransform, LoggerDetailContext valueChangeBean) {
        JSONObject jo = null;
        if (fieldElogTransform != null && StringUtils.isNotEmpty(fieldElogTransform.valuesKVPairs())) {
            jo = JSONObject.parseObject(fieldElogTransform.valuesKVPairs());
            if (jo != null) {
                valueChangeBean.setNewRealValue(jo.getString(newJo.getString(field.getName())));
                valueChangeBean.setOldRealValue(jo.getString(oldJo.getString(field.getName())));
            }
        }
    }

    public void setModuleName(String moduleName) {
        this.moduleName = moduleName;
    }

    public void setLocalQueue(String localQueue) {
        this.localQueue = localQueue;
    }

    public String getFunction() {
        return function;
    }

    public void setFunction(String function) {
        this.function = function;
    }

    public String getModule() {
        return module;
    }

    /**
     * 获取日志实体类
     *
     * @return
     */
    public LoggerContext getContext() {

        LoggerContext loggerContext = new LoggerContext();
        loggerContext.setUuid(UUID.randomUUID().toString().replace("-", ""));
        loggerContext.setModuleName(this.module);
        loggerContext.setFunctionName(this.function);

        return loggerContext;

    }

    public void setModule(String module) {
        this.module = module;
    }

//    public void setAsyncClient(AsyncClient asyncClient) {
//        this.asyncClient = asyncClient;
//    }


    public static Field[] getAllFields(Class obj) {
        Class superclass = obj.getSuperclass();
        Field[] superField = null;
        //获取父类
        if (superclass != Object.class) {
            superField = superclass.getDeclaredFields();
        }
        //获取当前类
        Field[] nowfield = obj.getDeclaredFields();
        return addFields(superField, nowfield);
    }

    public static Field[] addFields(Field[] superFields, Field[] fields) {

        return ArrayUtils.addAll(superFields, fields);

    }

    public void write(List<LoggerContext> context, boolean isLocal) {
        context.forEach(loggerContext -> {
            this.write(loggerContext, isLocal);
        });
    }


    public void write(List<LoggerContext> context) {
        context.forEach(loggerContext -> {
            this.write(loggerContext);
        });
    }

//    public void writeAsync(LoggerContext context, boolean isLocal){
//        String applicationNameBak =  this.applicationName;
//        String localQueueBak =  this.localQueue;
//        String moduleNameBak =  this.moduleName;
//        String pk =  this.publishkitGroup;
//        LocalRunnable localRunnable = new LocalRunnable() {
//            @Override
//            public void execute() {
//                String localQueueBakBak =  localQueueBak;
//                String elogLocalQueue =  ELOG + applicationNameBak;
//                if(StringUtils.isEmpty(localQueueBakBak))
//                    localQueueBakBak = (StringUtils.isNotEmpty(moduleNameBak) ? moduleNameBak : elogLocalQueue) + "LocalQueue" + pk;
//                AsyncBean<LoggerContext> asyncBean = new AsyncBean<>();
//                handleContext(context);
//                if (context.getWeakElogReocrd() && CollectionUtils.isEmpty(context.getDetailContexts() )) {
//                    logger.info("日志弱控且没有明细记录，不记录日志,modulename:{},functionname:{}",context.getModuleName(),context.getFunctionName());
//                    return;
//                }
//                try {
//                    asyncBean.setMessage(context);
//                    asyncBean.setQueue(logCenterQueue);
//                    checkAsyncBean(asyncBean);//检查消息体大小
//                    asyncClient.send(asyncBean);
//                    writeHrmLog(context);
//                    if(isLocal) {
//                        asyncBean.setQueue(localQueueBakBak);
//                        asyncClient.send(asyncBean);
//                    }
//                } catch (Exception e) {
//                    logger.error("发送mq消息异常！{}",e.getMessage(),e);
//                }
//            }
//        };
//        ThreadPoolUtil.fixedPoolExecute(ModulePoolEnum.OTHER, "LoggerTemplate_writeAsync", localRunnable);
//
//    }
//
//    /**
//     * 回滚队列
//     *
//     * @param context
//     */
//    public void writeRollBack(LoggerContext context){
//        String elogRollBackQueue =  ELOG + this.applicationName + "RollBackQueue" + this.publishkitGroup;
//        AsyncBean<LoggerContext> asyncBean = new AsyncBean<>();
//
//        try {
//            asyncBean.setMessage(context);
//            asyncBean.setQueue(elogRollBackQueue);
//            checkAsyncBean(asyncBean);//检查消息体大小
//            asyncClient.send(asyncBean);
//        } catch (Exception e) {
//            logger.error("发送mq消息异常！{}",e.getMessage(),e);
//        }
//    }

}
