package com.engine.salary.mapper.elog;

import com.engine.salary.elog.entity.dto.LoggerContext;
import com.engine.salary.elog.entity.dto.ReadInfoEntity;
import com.github.pagehelper.Page;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: LocalElogDao
 * @Description 本地操作日志持久层
 * @Author tanghj
 * @Date 2021/2/24 9:35
 */
public interface LocalElogDaoMapper {


    List<Map<String, Object>> queryCardElogList(@Param(value = "logContent") LoggerContext loggerContext,
                                                @Param("limit") String limit,
                                                @Param(value = "tableName") String tableName,
                                                @Param(value = "conditionSql") String conditionSql);

    List<Map> queryElogList(@Param(value = "page") Page page,
                            @Param(value = "logContent") LoggerContext loggerContext,
                            @Param("limit") String limit,
                            @Param(value = "tableName") String tableName,
                            @Param(value = "conditionSql") String conditionSql,
                            @Param(value = "columns") String columns);

    List<Map> queryElogListPapi(@Param(value = "page") Page page,
                                @Param(value = "logContent") LoggerContext loggerContext,
                                @Param("limit") String limit,
                                @Param(value = "tableName") String tableName,
                                @Param(value = "conditionSql") String conditionSql,
                                @Param(value = "columns") String columns);

    //    @WeaDataPermission(mainDataTable = "#{mainDataTable}",
//            permissionId = "#{permissionId}",
//            permissionType = "#{permissionType}",
//            mainDataTableAlias = "#{mainDataTableAlias}",
//            primaryKey = "#{primaryKey}",
//            permissionTargetId = "#{permissionTargetId}",
//            permissionConfigSourceId = "#{permissionConfigSourceId}",
//            permissionExcept = "true")
    List<Map> queryElogList(@Param(value = "page") Page page, @Param(value = "logContent") LoggerContext loggerContext,
                            @Param("limit") String limit,
                            @Param(value = "tableName") String tableName,
                            @Param(value = "conditionSql") String conditionSql,
                            @Param(value = "mainDataTable") String mainDataTable,
                            @Param(value = "permissionId") String permissionId,
                            @Param(value = "permissionType") String permissionType,
                            @Param(value = "mainDataTableAlias") String mainDataTableAlias,
                            @Param(value = "primaryKey") String primaryKey,
                            @Param(value = "permissionTargetId") String permissionTargetId,
                            @Param(value = "permissionConfigSourceId") String permissionConfigSourceId,
                            @Param(value = "columns") String columns
    );

    //    @WeaDataPermission(mainDataTable = "#{mainDataTable}",
//            permissionId = "#{permissionId}",
//            permissionType = "#{permissionType}",
//            mainDataTableAlias = "#{mainDataTableAlias}",
//            primaryKey = "#{primaryKey}",
//            permissionExcept = "true")
    List<Map> queryElogListPapi(@Param(value = "page") Page page, @Param(value = "logContent") LoggerContext loggerContext,
                                @Param("limit") String limit,
                                @Param(value = "tableName") String tableName,
                                @Param(value = "conditionSql") String conditionSql,
                                @Param(value = "mainDataTable") String mainDataTable,
                                @Param(value = "permissionId") String permissionId,
                                @Param(value = "permissionType") String permissionType,
                                @Param(value = "mainDataTableAlias") String mainDataTableAlias,
                                @Param(value = "primaryKey") String primaryKey,
                                @Param(value = "columns") String columns
    );

    List<Map> queryAllChanges(@Param(value = "tableName") String tableName, @Param("mainid") String mainid);

    Map<String, Object> elogCount(@Param(value = "logContent") LoggerContext loggerContext,
                                  @Param(value = "tableName") String tableName,
                                  @Param(value = "conditionSql") String conditionSql);

    Map<String, Object> elogCountPapi(@Param(value = "logContent") LoggerContext loggerContext,
                                      @Param(value = "tableName") String tableName,
                                      @Param(value = "conditionSql") String conditionSql);


    //    @WeaDataPermission(mainDataTable = "#{mainDataTable}",
//            permissionId = "#{permissionId}",
//            permissionType = "#{permissionType}",
//            mainDataTableAlias = "#{mainDataTableAlias}",
//            primaryKey = "#{primaryKey}",
//            permissionTargetId = "#{permissionTargetId}",
//            permissionConfigSourceId = "#{permissionConfigSourceId}",
//            permissionExcept = "true")
    Map<String, Object> elogCountByMorePermission(@Param(value = "logContent") LoggerContext loggerContext,
                                                  @Param(value = "tableName") String tableName,
                                                  @Param(value = "conditionSql") String conditionSql,
                                                  @Param(value = "mainDataTable") String mainDataTable,
                                                  @Param(value = "permissionId") String permissionId,
                                                  @Param(value = "permissionType") String permissionType,
                                                  @Param(value = "mainDataTableAlias") String mainDataTableAlias,
                                                  @Param(value = "primaryKey") String primaryKey,
                                                  @Param(value = "permissionTargetId") String permissionTargetId,
                                                  @Param(value = "permissionConfigSourceId") String permissionConfigSourceId);

    //    @WeaDataPermission(mainDataTable = "#{mainDataTable}",
//            permissionId = "#{permissionId}",
//            permissionType = "#{permissionType}",
//            mainDataTableAlias = "#{mainDataTableAlias}",
//            primaryKey = "#{primaryKey}",
//            permissionTargetId = "#{permissionTargetId}",
//            permissionConfigSourceId = "#{permissionConfigSourceId}",
//            permissionCount  = "count(*)",
//            permissionExcept = "true")
    Long elogCountOnlyNum(@Param(value = "logContent") LoggerContext loggerContext,
                          @Param(value = "tableName") String tableName,
                          @Param(value = "conditionSql") String conditionSql,
                          @Param(value = "mainDataTable") String mainDataTable,
                          @Param(value = "permissionId") String permissionId,
                          @Param(value = "permissionType") String permissionType,
                          @Param(value = "mainDataTableAlias") String mainDataTableAlias,
                          @Param(value = "primaryKey") String primaryKey,
                          @Param(value = "permissionTargetId") String permissionTargetId,
                          @Param(value = "permissionConfigSourceId") String permissionConfigSourceId);


    //    @WeaDataPermission(mainDataTable = "#{mainDataTable}",
//            permissionId = "#{permissionId}",
//            permissionType = "#{permissionType}",
//            mainDataTableAlias = "#{mainDataTableAlias}",
//            primaryKey = "#{primaryKey}",
//            permissionExcept = "true")
    Map<String, Object> elogCount(@Param(value = "logContent") LoggerContext loggerContext,
                                  @Param(value = "tableName") String tableName,
                                  @Param(value = "conditionSql") String conditionSql,
                                  @Param(value = "mainDataTable") String mainDataTable,
                                  @Param(value = "permissionId") String permissionId,
                                  @Param(value = "permissionType") String permissionType,
                                  @Param(value = "mainDataTableAlias") String mainDataTableAlias,
                                  @Param(value = "primaryKey") String primaryKey);

    //    @WeaDataPermission(mainDataTable = "#{mainDataTable}",
//            permissionId = "#{permissionId}",
//            permissionType = "#{permissionType}",
//            mainDataTableAlias = "#{mainDataTableAlias}",
//            primaryKey = "#{primaryKey}",
//            permissionExcept = "true")
    Map<String, Object> elogCountPapi(@Param(value = "logContent") LoggerContext loggerContext,
                                      @Param(value = "tableName") String tableName,
                                      @Param(value = "conditionSql") String conditionSql,
                                      @Param(value = "mainDataTable") String mainDataTable,
                                      @Param(value = "permissionId") String permissionId,
                                      @Param(value = "permissionType") String permissionType,
                                      @Param(value = "mainDataTableAlias") String mainDataTableAlias,
                                      @Param(value = "primaryKey") String primaryKey);


    List<Map> queryDetailElogList(@Param(value = "logContent") LoggerContext loggerContext,
                                  @Param("limit") String limit,
                                  @Param(value = "tableName") String tableName,
                                  @Param(value = "conditionSql") String conditionSql);

    Map<String, Object> elogDetailCount(@Param(value = "logContent") LoggerContext loggerContext,
                                        @Param(value = "tableName") String tableName,
                                        @Param(value = "conditionSql") String conditionSql);

//    List<SimpleEmployee> queryOperators(@Param(value = "tableName") String tableName,
//                                        @Param(value = "targetId") String targetId,
//                                        @Param(value = "operateType") String operateType);

    List<ReadInfoEntity> queryReadInfoOperators(@Param(value = "tableName") String tableName,
                                                @Param(value = "targetId") String targetId,
                                                @Param(value = "operateType") String operateType,
                                                @Param(value = "flag") Boolean flag);

    List<ReadInfoEntity> queryReadInfoDateOperators(@Param(value = "tableName") String tableName,
                                                    @Param(value = "targetId") String targetId,
                                                    @Param(value = "operateType") String operateType,
                                                    @Param(value = "flag") Boolean flag,
                                                    @Param(value = "startDate") String startDate,
                                                    @Param(value = "endDate") String endDate);

    List<Map> queryAllMainData(@Param(value = "tableName") String tableName, @Param("uuid") String uuid);

    List<Map> queryAllMainChanges(@Param(value = "tableName") String tableName, @Param("mainid") String mainid);

    List<Map> queryAllDetailChanges(@Param(value = "tableName") String tableName, @Param("mainid") String mainid);

    Integer queryElogContextById(@Param(value = "id") Long id,
                                 @Param(value = "tableName") String tableName);

    List<Map> queryElogTraceInfo(@Param(value = "traceId") String traceId,
                                 @Param(value = "tableName") String tableName,
                                 @Param(value = "offset") Integer offset,
                                 @Param(value = "pageSize") Integer pageSize);

    int queryElogTraceInfoCount(@Param(value = "traceId") String traceId,
                                @Param(value = "tableName") String tableName);

    List queryLogInfoByCustom(@Param(value = "tableName") String tableName,
                              @Param(value = "sql") String sql);

    List queryAllChangesData(@Param("tableName") String tableName, @Param("mainid") String mainid);

    List<ReadInfoEntity> queryTenantKeyOperators(@Param(value = "tableName") String tableName,
                                                 @Param(value = "tenantKey") String tenantKey,
                                                 @Param(value = "targetId") String targetId,
                                                 @Param(value = "operateType") String operateType,
                                                 @Param(value = "flag") Boolean flag);

    List<Map> queryAllChangesDataPages(@Param("tableName") String tableName,
                                       @Param("mainid") String mainid,
                                       @Param(value = "page") Page page);

    Integer queryAllChangesPageCounts(@Param("tableName") String tableName, @Param("mainid") String mainid);
}
